#pragma once

#include "SDL/SDL-1.2.14 sdk/include/SDL.h" // main SDL header

#include "App_SdlEvent.h"

struct SDL_Surface;
namespace Gfx {class Font;}
namespace Input {class InputMngr;}
namespace Layers {class All;}

namespace App
{
	class Main : public SdlEvent
	{
	public:

		Main (int argc, _TCHAR* argv[]);
		virtual ~Main ();

		int OnExecute ();

	protected:

		virtual void OnExit();
		virtual void OnKeyDown (SDLKey sym, SDLMod mod, Uint16 unicode);
		virtual void OnKeyUp (SDLKey sym, SDLMod mod, Uint16 unicode);
		virtual void OnMouseMove (int x, int y, int dx, int dy, bool l, bool r, bool m);
		virtual void OnLButtonDown (int mX, int mY);
		virtual void OnLButtonUp (int mX, int mY);
		virtual void OnRButtonDown (int mX, int mY);
		virtual void OnRButtonUp (int mX, int mY);
		virtual void OnMButtonDown (int mX, int mY);
		virtual void OnMButtonUp (int mX, int mY);
		virtual void OnMWheelDown (bool isUpClick);
		virtual void OnMouseEnterWindow ();
		virtual void OnMouseLeaveWindow ();
		virtual void OnInputFocusGained ();
		virtual void OnInputFocusLost ();
		virtual void OnVisible ();
		virtual void OnInvisible ();
		virtual void OnResize (int w,int h);

	private:

		void ParseCommandLineArgs (int argc, _TCHAR* argv[]);

		bool OnInit ();
		void OnEvent (SDL_Event * Event);
		void OnLoop ();
		void OnRender ();
		void OnCleanup ();

		bool isRunning;

		SDL_Surface * Surf_Display;

		Gfx::Font * font;

		Input::InputMngr * inputMngr;
		
		Layers::All * layers;

		RakNet::Time timePrev;
		RakNet::Time timeStepAccumulator;

		char * settingsFilename;
	};
}
