#include "stdafx.h"

#include "App_SdlEvent.h"

namespace App
{
	SdlEvent::SdlEvent() 
	{
		//result = SDL_EnableUNICODE (1);
		//assert (result == 0);
	}

	SdlEvent::~SdlEvent() 
	{
		//Do nothing
	}

	void SdlEvent::OnEvent(SDL_Event* Event) 
	{
		switch(Event->type) 
		{
		case SDL_ACTIVEEVENT: 
			{
				if (Event->active.state & SDL_APPMOUSEFOCUS)
				{
					if ( Event->active.gain )   
					{
						OnMouseEnterWindow ();
					}
					else                 
					{	
						OnMouseLeaveWindow ();
					}
				}

				if (Event->active.state & SDL_APPINPUTFOCUS)
				{
					if ( Event->active.gain )   
					{
						OnInputFocusGained ();
					}
					else                
					{
						OnInputFocusLost ();
					}
				}

				if (Event->active.state & SDL_APPACTIVE)
				{
					if ( Event->active.gain )   
					{
						OnVisible();
					}
					else                
					{	
						OnInvisible();
					}
				}
			}

		case SDL_KEYDOWN: 
			{
				if (Event->key.keysym.unicode != 0)
				{
					int i = 0;
				}
			
				if (Event->key.keysym.sym != SDLK_UNKNOWN && Event->key.keysym.sym != SDLK_LSHIFT)
				{
					int i = 0;
				}

			OnKeyDown(Event->key.keysym.sym,Event->key.keysym.mod,Event->key.keysym.unicode);
			break;
			}

		case SDL_KEYUP: 
			{
			OnKeyUp(Event->key.keysym.sym,Event->key.keysym.mod,Event->key.keysym.unicode);
			break;
			}

		case SDL_MOUSEMOTION: 
			{
			OnMouseMove(Event->motion.x,Event->motion.y,Event->motion.xrel,Event->motion.yrel,(Event->motion.state&SDL_BUTTON(SDL_BUTTON_LEFT))!=0,(Event->motion.state&SDL_BUTTON(SDL_BUTTON_RIGHT))!=0,(Event->motion.state&SDL_BUTTON(SDL_BUTTON_MIDDLE))!=0);
			break;
			}

		case SDL_MOUSEBUTTONDOWN: 
			{
				switch(Event->button.button) 
				{
				case SDL_BUTTON_LEFT: 
					OnLButtonDown(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_RIGHT:
					OnRButtonDown(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_MIDDLE: 
					OnMButtonDown(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_WHEELUP:
				case SDL_BUTTON_WHEELDOWN:
					OnMWheelDown(Event->button.button == SDL_BUTTON_WHEELUP);
					break;
				}
				break;
			}

		case SDL_MOUSEBUTTONUP: 
			{
				switch(Event->button.button) 
				{
				case SDL_BUTTON_LEFT:
					OnLButtonUp(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_RIGHT:
					OnRButtonUp(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_MIDDLE:
					OnMButtonUp(Event->button.x,Event->button.y);
					break;
				case SDL_BUTTON_WHEELUP:
				case SDL_BUTTON_WHEELDOWN:
					// is it safe to ignore these?
					break;
				}
				break;
			}

		case SDL_JOYAXISMOTION: {
			OnJoyAxis(Event->jaxis.which,Event->jaxis.axis,Event->jaxis.value);
			break;
								}

		case SDL_JOYBALLMOTION: {
			OnJoyBall(Event->jball.which,Event->jball.ball,Event->jball.xrel,Event->jball.yrel);
			break;
								}

		case SDL_JOYHATMOTION: {
			OnJoyHat(Event->jhat.which,Event->jhat.hat,Event->jhat.value);
			break;
							   }
		case SDL_JOYBUTTONDOWN: {
			OnJoyButtonDown(Event->jbutton.which,Event->jbutton.button);
			break;
								}

		case SDL_JOYBUTTONUP: {
			OnJoyButtonUp(Event->jbutton.which,Event->jbutton.button);
			break;
							  }

		case SDL_QUIT: {
			OnExit();
			break;
					   }

		case SDL_SYSWMEVENT: {
			//Ignore
			break;
							 }

		case SDL_VIDEORESIZE: {
			OnResize(Event->resize.w,Event->resize.h);
			break;
							  }

		case SDL_VIDEOEXPOSE: {
			OnExpose();
			break;
							  }

		default: {
			OnUser(Event->user.type,Event->user.code,Event->user.data1,Event->user.data2);
			break;
				 }
		}
	}

	void SdlEvent::OnInputFocusGained () {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnInputFocusLost () {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnKeyDown(SDLKey sym, SDLMod mod, Uint16 unicode) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnKeyUp(SDLKey sym, SDLMod mod, Uint16 unicode) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMouseEnterWindow () {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMouseLeaveWindow () {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMouseMove(int mX, int mY, int relX, int relY, bool Left,bool Right,bool Middle) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMouseWheel(bool Up, bool Down) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnLButtonDown(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnLButtonUp(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnRButtonDown(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnRButtonUp(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMButtonDown(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMButtonUp(int mX, int mY) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnMWheelDown(bool isUpClick) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnJoyAxis(Uint8 which,Uint8 axis,Sint16 value) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnJoyButtonDown(Uint8 which,Uint8 button) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnJoyButtonUp(Uint8 which,Uint8 button) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnJoyHat(Uint8 which,Uint8 hat,Uint8 value) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnJoyBall(Uint8 which,Uint8 ball,Sint16 xrel,Sint16 yrel) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnVisible() {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnInvisible() {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnResize(int w,int h) {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnExpose() {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnExit() {
		//Pure virtual, do nothing
	}

	void SdlEvent::OnUser(Uint8 type, int code, void* data1, void* data2) {
		//Pure virtual, do nothing
	}
}
