#pragma once

namespace ClientEnts {struct UpdateData;}
namespace Gfx {class Font;}
namespace LayerPlaying {class WorldSyncMngr;}
namespace Layers {class All;}
namespace Ld {class ColumnMask;}
namespace SceneGfx {class World;}
namespace SceneFile {class SimFactory;}
namespace SceneSim {class World;}

namespace LayerEditing
{
	class Editing
	{
	public:

		Editing (Layers::All * all);
		~Editing ();

		void Preupdate (ClientEnts::UpdateData * update);
		void Update (ClientEnts::UpdateData * update);
		void UpdateFractionBlend (ClientEnts::UpdateData * update, float weight);
		void Render ();

		bool GetIsRunning () const;

		bool isRunningRequested;

	private:

		void InitEnts (ClientEnts::UpdateData * update);
		void UpdateWorld (ClientEnts::UpdateData * update, bool isLoadingFinished);

		enum STATES
		{
			S_NONE,
			S_LOADINGSIM,
			S_GENERATINGGFX,
			S_PLAYING,
		};

		STATES state;

		bool isRunning;
		bool isLoadingComplete;
		bool isGraphicsComplete;

		Layers::All * all;

		Gfx::Font * font;

		LayerPlaying::WorldSyncMngr * worldSyncMngr;
		SceneSim::World * simWorld;
		SceneGfx::World * gfxWorld;

		ClientEnts::UpdateData * update;

		Ld::ColumnMask * columnMask;
	};
}
