#pragma once

namespace Gfx {class Font;}
namespace Gfx {class GfxTex;}
namespace Gfx {class Viewport;}
namespace Input {class InputMngr;}
namespace Layers {class All;}
namespace Menus {class Page;}
namespace Menus {class Pages;}
namespace Menus {namespace Controls {class Button;}}

namespace LayerFrontEnd
{
	class FrontEnd
	{
	public:
		
		FrontEnd (Layers::All * all, Input::InputMngr * inputMngr);
		~FrontEnd ();

		void Preupdate ();
		void Update ();
		void Render ();

		bool isRunningRequested;

	private:

		static bool OnCreateNewInfiniteLevel (Menus::Controls::Button * button, void * data);
		static bool OnConnectToServer (Menus::Controls::Button * button, void * data);
		static bool OnQuitToDesktop (Menus::Controls::Button * button, void * data);

		static void OnWorldEditEntry (Menus::Page * page, void * data);
		static bool OnEditLevelSelected (Menus::Controls::Button * control, void * data);
		static void OnWorldPlayEntry (Menus::Page * page, void * data);
		static bool OnPlayLevelSelected (Menus::Controls::Button * control, void * data);
		static void OnSaveSettings (Menus::Page * page, void * data);
		static bool OnDrawDistanceToggled (Menus::Controls::Button * button, void * data);

		bool isRunning;

		Layers::All * all;
		Input::InputMngr * inputMngr;
		Gfx::Font * font;

		Menus::Pages * pages;
	};
}
