#pragma once

namespace ClientEnts {struct UpdateData;}
namespace Gfx {class Font;}
namespace LayerPlaying {class WorldSyncMngr;}
namespace Layers {class All;}
namespace SceneGfx {class World;}
namespace SceneFile {class SimFactory;}
namespace SceneSim {class World;}
namespace Tiny {class TinyWorlds;}

namespace LayerPlaying
{
	class Playing
	{
	public:

		Playing (Layers::All * all);
		~Playing ();

		void Preupdate (ClientEnts::UpdateData * update);
		void Update (ClientEnts::UpdateData * update);
		void UpdateFractionBlend (ClientEnts::UpdateData * update, float weight);
		void Render ();

		bool GetIsRunning () const;

		bool isRunningRequested;

	private:

		void DeleteAll ();
		void InitEnts (ClientEnts::UpdateData * update);
		void UpdateWorld (ClientEnts::UpdateData * update, bool isLoadingFinished);
		void SwapSimAndGfxColumns (Int3 a, Int3 b);

		enum STATES
		{
			S_NONE,
			S_LOADINGSIM,
			S_GENERATINGGFX,
			S_PLAYING,
		};

		STATES state;

		bool isRunning;
		bool isLoadingComplete;
		bool isGraphicsComplete;

		Layers::All * all;

		Gfx::Font * font;

		WorldSyncMngr * worldSyncMngr;
		SceneSim::World * simWorld;
		SceneGfx::World * gfxWorld;

		ClientEnts::UpdateData * update;

		Ld::ColumnMask * columnMask;
		Ld::ColumnMask * homeOnlyMask;

		Tiny::TinyWorlds * tinyWorlds;
	};
}
