#pragma once

#include "../Tiny/Tiny_TinyWorlds.h"

namespace Gfx {class Font;}
namespace Gfx {class Viewport;}
namespace Input {class InputMngr;}
namespace Layers {class All;}
namespace Menus {class Page;}
namespace Menus {namespace Controls {class Button;}}
namespace Menus {namespace Controls {class Title1;}}
namespace Menus {namespace Controls {class Title2;}}

namespace LayerPlaying
{
	class PlayingDialog
	{
	public:
		
		PlayingDialog (Layers::All * all, Input::InputMngr * inputMngr);
		~PlayingDialog ();

		void ShowDialog (Tiny::TINYITEMS item);
		void ShowWarnHotDialog ();
		void ShowWarnColdDialog ();
		void ShowDialogArtifacts (int artifacts, int maxArtifacts);
		void ShowDead ();

		void Preupdate ();
		void Update ();
		void Render ();

		bool GetIsRunning () const;
		void Reset ();

		bool isRunningRequested;

	private:

		static bool OnDrawDistanceToggled (Menus::Controls::Button * button, void * data);


		bool isRunning;

		Layers::All * all;
		Input::InputMngr * inputMngr;
		Gfx::Font * font;

		Menus::Page * page;

		Menus::Controls::Button * returnToGameButton;
		
		Menus::Controls::Title2 * title;
		Menus::Controls::Title1 * text1;
		Menus::Controls::Title1 * text2;
		Menus::Controls::Title1 * text3;

		Tiny::TINYITEMS item;

		bool hasShownHot;
		bool hasShownCold;
		bool hasWon;
	};
}
