#pragma once

namespace Gfx {class Font;}
namespace Gfx {class Viewport;}
namespace Input {class InputMngr;}
namespace Layers {class All;}
namespace Menus {class Page;}
namespace Menus {namespace Controls {class Button;}}

namespace LayerPlaying
{
	class PlayingMenus
	{
	public:
		
		PlayingMenus (Layers::All * all, Input::InputMngr * inputMngr);
		~PlayingMenus ();

		void Preupdate ();
		void Update ();
		void Render ();

		bool GetIsRunning () const;

		bool isRunningRequested;

	private:

		static void OnSaveSettings (Menus::Page * page, void * data);
		static bool OnDrawDistanceToggled (Menus::Controls::Button * button, void * data);


		bool isRunning;

		Layers::All * all;
		Input::InputMngr * inputMngr;
		Gfx::Font * font;

		Menus::Page * page;

		Menus::Controls::Button * returnToGameButton;
		Menus::Controls::Button * quitToFrontEndButton;
	};
}
