#pragma once

namespace GfxFactory {class GfxFactory;}
namespace SceneFile {class SimFactory;}
namespace SceneGfx {class World;}
namespace SceneSim {class CellChangeData;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}

#include "SceneHelper/SceneHelper_SimEvents.h"

namespace LayerPlaying
{
	class WorldSyncMngr : public SceneHelper::SimEvents
	{
	public:

		bool IsSimReady;
		bool IsGfxReady;

		WorldSyncMngr (SceneSim::World * simWorld, SceneGfx::World * gfxWorld, bool isEditMode);
		~WorldSyncMngr ();

		void Update ();

		void ApplyCsg (RakNet::Time * time, TextRef roomId, Int3 columnId, Int3 cellId, float radius, int cellType, int cellData);

		virtual void OnWorldAdded (SceneSim::World * world);
		virtual void OnWorldRemoved (SceneSim::World * world);
		virtual void OnRoomAdded (SceneSim::Room * room);
		virtual void OnRoomRemoved (SceneSim::Room * room);
		virtual void OnColumnAdded (SceneSim::Column * column);
		virtual void OnColumnRemoved (SceneSim::Column * column);
		virtual void OnTerrainCsgApplied (SceneSim::Column * column, Int3 cellId, float radius, int cellType);

		void PauseUntilSynced ();
		void SaveAndUnload ();

	private:

		void InitialiseWorld ();
		bool GenerateInitialSim ();
		bool GenerateInitialGfx ();

		bool isEditMode;

		int gfxColumnInitCount;

		SceneSim::World * simWorld;
		SceneGfx::World * gfxWorld;

		SceneFile::SimFactory * simFactory;
		GfxFactory::GfxFactory * gfxFactory;
	};
}
