#pragma once

#include "../ClientEnts/ClientEnts_UpdateData.h"

namespace ClientEnts {struct UpdateData;}
namespace Input {class InputMngr;}
namespace LayerEditing {class Editing;}
namespace LayerEditing {class EditingMenus;}
namespace LayerFrontEnd {class FrontEnd;}
namespace LayerPlaying {class Playing;}
namespace LayerPlaying {class PlayingMenus;}
namespace LayerPlaying {class PlayingDialog;}

namespace Layers
{
	class All
	{
	public:
		
		All (Input::InputMngr * inputMngr);
		~All ();

		void Update (RakNet::Time timeNow, float timeStepInSeconds);
		void UpdateFractionBlend (RakNet::Time timeNow, float weight);
		void Render ();

		// all layers

		LayerFrontEnd::FrontEnd * frontEnd;
		LayerEditing::Editing * editing;
		LayerEditing::EditingMenus * editingMenus;
		LayerPlaying::Playing * playing;
		LayerPlaying::PlayingMenus * playingMenus;
		LayerPlaying::PlayingDialog * playingDialog;

		// communication to the main app

		bool isQuitRequested;

	private:

		// data shared across and passed to the layers

		ClientEnts::UpdateData update;
	};
}
