#pragma once

namespace Gfx {class Font;}
namespace Input {class InputMngr;}
namespace Menus {class Page;}

namespace Menus
{
	namespace Controls
	{
		class Base
		{
		public:

			Base (Int2 tl) : isHighlighted (false), isFocused (false), tl (tl), page (NULL) {}
			virtual ~Base () {}

			virtual bool IsHighlighted (Int2 cursor) const {return false;}
			virtual bool IsHighlightable () const {return false;}

			virtual bool IsUsingAllKeyInput () const {return false;}

			virtual void SetIsHighlighted (bool isHighlighted) {this->isHighlighted = isHighlighted;}
			virtual void SetIsFocused (bool isFocused) {this->isFocused = isFocused;}

			virtual void Update (Input::InputMngr * inputMngr) {}
			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font) {}

			bool isHighlighted;
			bool isFocused;
			Int2 tl;

			Page * page;
		};
	}
}
