#pragma once

#include "Controls_Base.h"

namespace Menus
{
	namespace Controls
	{
		class Button : public Base
		{
		public:

			typedef bool (*OnExecuted) (Button * button, void * data);

			Button (Int2 tl, TextRef label);
			Button (Int2 tl, TextRef label, OnExecuted onExecuted, void * data);
			virtual ~Button ();

			virtual bool IsHighlighted (Int2 cursor) const;
			virtual bool IsHighlightable () const {return true;}

			virtual void Update (Input::InputMngr * inputMngr);
			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font);

			virtual bool Executed ();

			const Text label;
			bool wasPressed;

		protected:

			OnExecuted onExecuted;
			void * data;
		};
	}
}
