#pragma once

#include "Controls_Base.h"

namespace Menus
{
	namespace Controls
	{
		class RecordKey : public Base
		{
		public:

			typedef bool (*IsUniqueKey) (SDLKey key);

			RecordKey (Int2 tl, const char * label, SDLKey * key, IsUniqueKey isUniqueKey);
			virtual ~RecordKey ();

			virtual bool IsHighlighted (Int2 cursor) const;
			virtual bool IsHighlightable () const {return true;}

			virtual bool IsUsingAllKeyInput () const {return isAwaitingNewKey;}

			virtual void SetIsFocused (bool isFocused);

			virtual void Update (Input::InputMngr * inputMngr);
			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font);

			const char * label;
			SDLKey * key;

		private:

			IsUniqueKey isUniqueKey;
			bool isAwaitingNewKey;
			int blinker;
		};
	}
}
