#include "stdafx.h"

#include "Gfx/Gfx_Font.h"
#include "Input/Input_InputMngr.h"
#include "Input/Input_Keys.h"
#include "Input/Input_Mouse.h"

#include "Controls_SingleScore.h"
#include "Menus_Draw.h"
#include "Menus_Palette.h"

namespace Menus
{
	namespace Controls
	{
		SingleScore::SingleScore (Int2 tl, Text name, int kills, int deaths) 
			: Base (tl)
		{
			this->name = name;
			this->kills = Text::Format ("%d kill%c", kills, (kills == 1) ? ' ' : 's');
			this->deaths = Text::Format ("%d death%c", deaths, (deaths == 1) ? ' ' : 's');
		}

		SingleScore::~SingleScore () 
		{
		}

		void SingleScore::Render (Int2 offset, int passIdx, Gfx::Font * font)
		{
			const Palette * p = Palette_Get (isFocused);

			if (passIdx == 0)
			{
				Draw_BoxOutline (offset + tl, p->labelSize, p->thickness, p->border, p->fill);
				Draw_BoxOutline (offset + tl + p->labelControl, p->labelSize, p->thickness, p->border, p->fill);
			}
			else
			{
				Draw_Text (offset + tl + p->textOffset, name.Raw (), font);
				Draw_Text (offset + tl + p->labelControl + p->textOffset, kills.Raw (), font);
				Draw_Text (offset + tl + p->labelControl + p->textOffset + Int2 (200, 0), deaths.Raw (), font);
			}
		}
	}
}
