#pragma once


#include "Controls_Base.h"

namespace Menus
{
	namespace Controls
	{
		class TextEntry : public Base
		{
		public:

			TextEntry (Text::VALIDATETYPES entryType, Int2 tl, const char * label, int maxLength, Text * text);
			virtual ~TextEntry ();

			virtual bool IsHighlighted (Int2 cursor) const;
			virtual bool IsHighlightable () const {return true;}

			virtual void SetIsFocused (bool isFocused);

			virtual void Update (Input::InputMngr * inputMngr);
			virtual void Render (Int2 offset, int passIdx, Gfx::Font * font);

			const char * label;
			Text * text;
			const Text::VALIDATETYPES entryType;

		private:

			const int maxLength;
			int blinker;
		};
	}
}
