#include "stdafx.h"

#include "Gfx/Gfx_Font.h"

#include "Controls_Title1.h"
#include "Menus_Draw.h"
#include "Menus_Palette.h"

namespace Menus
{
	namespace Controls
	{
		Title1::Title1 (Int2 tl, const char * label) 
			: Base (tl),
			label (strdup (label))
		{
		}

		Title1::~Title1 () 
		{
			delete [] label;
		}

		void Title1::SetText (const char * label)
		{
			delete [] this->label;
			this->label = strdup (label);
		}

		void Title1::Render (Int2 offset, int passIdx, Gfx::Font * font)
		{
			const Palette * p = Palette_Get (isFocused);

			int textLength = font->GetLength (label);

			Int2 length ((p->labelSize.x - textLength) / 2, p->textOffset.y);

			if (passIdx == 0)
			{
				Draw_Box (offset + tl + p->centreLabelPos + Int2 (length.x - 10, 0), Int2 (textLength + 20, p->labelSize.y), Int4 (0, 0, 0, 255));
			}
			else
			{
				Draw_Text (offset + tl + p->centreLabelPos + length, label, font);
			}
		}
	}
}
