#include "stdafx.h"

#include "Controls_Title2.h"
#include "Menus_Draw.h"
#include "Menus_Palette.h"

namespace Menus
{
	namespace Controls
	{
		Title2::Title2 (Int2 tl, const char * label) 
			: Base (tl),
			label (strdup (label))
		{
		}

		Title2::~Title2 () 
		{
			delete [] label;
		}

		void Title2::SetText (const char * label)
		{
			delete [] this->label;
			this->label = strdup (label);
		}

		void Title2::Render (Int2 offset, int passIdx, Gfx::Font * font)
		{
			const Palette * p = Palette_Get (isFocused);
			Int2 fullWidth (-offset.x, tl.y);
			Int2 fullSize (2000, p->labelSize.y);

			if (passIdx == 0)
			{
				Draw_Box (offset + fullWidth, fullSize, p->fill);
			}
			else
			{
				Draw_Text (offset + tl + p->textOffset, label, font);
			}
		}
	}
}
