#include "stdafx.h"

#include "Menus_Page.h"
#include "Menus_Pages.h"

namespace Menus
{
	Pages::Pages ()
		: currentOpen (NULL)
	{
	}

	Pages::~Pages ()
	{
		for (PageCollectionIt it = collection.begin(); it != collection.end(); ++it)
		{
			delete it->second;
		}

		collection.clear ();
	}

	void Pages::OpenPage (TextRef id, bool resetPage)
	{
		Page * next = GetPage (id);
		if (next != currentOpen)
		{
			if (currentOpen != NULL)
			{
				currentOpen->SetActive (false);
			}

			currentOpen = next;
			currentOpen->SetActive (true);
			currentOpen->Init (resetPage);
		}
	}

	void Pages::Update ()
	{
		if (currentOpen != NULL)
		{
			currentOpen->Update ();
		}
	}

	void Pages::Render ()
	{
		if (currentOpen != NULL)
		{
			currentOpen->Render ();
		}
	}

	Page * Pages::AddPage (Page * page)
	{
		collection.insert (std::pair <Text, Page *> (page->Id, page));
		return page;
	}

	Page * Pages::GetPage (TextRef id)
	{
		PageCollectionIt it = collection.find (id);
		assert (it != collection.end ());
		return it->second;
	}
}
