#pragma once

#include "SDL/SDL-1.2.14 sdk/include/Sdl.h"

#include "SceneSim/SceneSim_WorldInit.h"

namespace Lua {class LuaState;}

namespace Session
{
	class Settings
	{
	public:

		enum GAMEMODES
		{
			GM_PLAY,
			GM_EDIT,
			GM_NONE,
		};

		static void Load (TextRef settingsFilename);
		static void Unload ();
		static void Save ();

		static Settings & Get ();

		//unsigned int GetWorldRandomSeed ();

		GAMEMODES gamemode;

		// single player settings

		Text worldsFolder;
		Text defaultWorld;

		// multiplayer settings

		Text connectToIp;
		Text connectToPort;
		Text listenToPort;

		// 

		int drawDistance;

		SceneSim::WorldInit worldInitParams;

		// player settings

		bool isCameraInverted;
		Text nickname;
		Vec3 rgb;

		// player controls

		SDLKey up;
		SDLKey down;
		SDLKey left;
		SDLKey right;
		SDLKey jump;
		SDLKey crouch;
		SDLKey chat;
		SDLKey showScores;

	private:

		Settings (TextRef settingsFilename);
		~Settings ();

		Text settingsFilename;
		Lua::LuaState * clientSettingsLua;

		static Settings * instance;
	};
}
