#include "stdafx.h"

#include "Ld/Ld_ColumnMask.h"

#include "Tiny_TinyWorld.h"
#include "Tiny_TinyWorlds.h"

namespace Tiny
{
	TINYITEMS items [TN_NONE];

	TinyWorlds::TinyWorlds (SceneGfx::World * gfxWorld)
		: gfxWorld (gfxWorld)
	{
		Int3 * world = NULL;

		for (int idx = 0; idx < TN_NONE; ++idx) 
		{
			items [idx] = TI_NONE;
		}

		items [TN_GRASS_03] = TI_JUMP_1;
		items [TN_GRASS_04] = TI_AXE;
		items [TN_COLDWORLD] = TI_BELT;
		items [TN_ASTEROID_10] = TI_SHIELDCOLD;
		items [TN_VECTOR] = TI_SHIELDHOT;
		items [TN_DESERTWORLD] = TI_TELEPORTER;
		items [TN_ASTEROID_4] = TI_JUMP_2;
		items [TN_SWAMP] = TI_SEEDS;
		items [TN_ROBOTWORLD] = TI_BIGAXE;
			
		world = aah_new Int3 [1]; // home
		world [0] = Int3 (1, 0, 1);
		worlds.push_back (aah_new TinyWorld (TN_HOME, "Tiny Homeworld", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// grass 1
		world = aah_new Int3 [1];
		world [0] = Int3 (3, 0, 2);
		worlds.push_back (aah_new TinyWorld (TN_GRASS_01, "Grass World 1", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// grass 2
		world = aah_new Int3 [1];
		world [0] = Int3 (0, 0, 3);
		worlds.push_back (aah_new TinyWorld (TN_GRASS_02, "Grass World 2", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// grass 3
		world = aah_new Int3 [1];
		world [0] = Int3 (5, 0, 0);
		worlds.push_back (aah_new TinyWorld (TN_GRASS_03, "Grass World 3", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// grass 4
		world = aah_new Int3 [1];
		world [0] = Int3 (4, 0, 11);
		worlds.push_back (aah_new TinyWorld (TN_GRASS_04, "Grass World 4", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// 
		world = aah_new Int3 [1];
		world [0] = Int3 (9, 0, 3);
		worlds.push_back (aah_new TinyWorld (TN_NONE, "Grass World 5", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// cold planet
		world = aah_new Int3 [1];
		world [0] = Int3 (15, 0, 0);
		worlds.push_back (aah_new TinyWorld (TN_COLDWORLD, "Ice World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// sun
		world = aah_new Int3 [1];
		world [0] = Int3 (10, 0, 10);
		worlds.push_back (aah_new TinyWorld (TN_SUN, "The Sun", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		//// fire planet
		//world = aah_new Int3 [1];
		//world [0] = Int3 (8, 0, 7);
		//worlds.push_back (aah_new TinyWorld (TN_FIREWORLD, "Fire World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// swamp planet
		world = aah_new Int3 [1];
		world [0] = Int3 (1, 0, 14);
		worlds.push_back (aah_new TinyWorld (TN_SWAMP, "Rot World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// left middle 
		world = aah_new Int3 [1];
		world [0] = Int3 (3, 0, 8);
		worlds.push_back (aah_new TinyWorld (TN_VECTOR, "Vector World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// robot
		world = aah_new Int3 [1];
		world [0] = Int3 (13, 0, 12);
		worlds.push_back (aah_new TinyWorld (TN_ROBOTWORLD, "Nuclear Waste World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// desert
		world = aah_new Int3 [1];
		world [0] = Int3 (9, 0, 13);
		worlds.push_back (aah_new TinyWorld (TN_DESERTWORLD, "Desert World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		//// right middle
		//world = aah_new Int3 [1];
		//world [0] = Int3 (12, 0, 6);
		//worlds.push_back (aah_new TinyWorld (TN_NONE, "Unknown World", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		// asteroids
		world = aah_new Int3 [1];
		world [0] = Int3 (5, 0, 5);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_0, "Asteroids 1", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (7, 0, 5);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_1, "Asteroids 2", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (10, 0, 5);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_2, "Asteroids 3", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (14, 0, 5);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_3, "Asteroids 4", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (15, 0, 7);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_4, "Asteroids 5", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (15, 0, 11);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_5, "Asteroids 6", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (15, 0, 13);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_6, "Asteroids 7", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (14, 0, 15);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_7, "Asteroids 8", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (11, 0, 15);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_8, "Asteroids 9", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (7, 0, 15);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_9, "Asteroids 10", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (5, 0, 15);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_10, "Asteroids 11", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (5, 0, 12);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_11, "Asteroids 12", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

		world = aah_new Int3 [1];
		world [0] = Int3 (5, 0, 8);
		worlds.push_back (aah_new TinyWorld (TN_ASTEROID_12, "Asteroids 13", Vec3 (0.0f, 0.0f, 0.0f), world, 1, gfxWorld));

	}

	TinyWorlds::~TinyWorlds ()
	{
	}

	void TinyWorlds::Update ()
	{
	}

	void TinyWorlds::Render (Int3 columnId, Vec3 colRelPos)
	{
		for (int idx = 0; idx < worlds.size (); ++idx)
		{
			worlds [idx]->Render ();
		}
	}

	void TinyWorlds::SetMask (Ld::ColumnMask * columnMask)
	{
		columnMask->Set (false);

		for (int idx = 0; idx < worlds.size (); ++idx)
		{
			TinyWorld * world = worlds [idx];
			for (int s = 0; s < world->sourceCount; ++s)
			{
				columnMask->use [world->source [s].x][world->source [s].z] = true;
			}
		}
	}



	TINYITEMS TinyWorlds::FindItem (Int3 columnId) const
	{
		TINYNAMES name = FindName (columnId);

		TINYITEMS item = TI_NONE;
		if (name != TN_NONE)
		{
			item = items [name];
			items [name] = TI_NONE; // can only collect it once
		}

		return item;
	}

	TINYNAMES TinyWorlds::FindName (Int3 columnId) const
	{
		for (int idx = 0; idx < worlds.size (); ++idx)
		{
			const TinyWorld * world = worlds [idx];
			for (int s = 0; s < world->sourceCount; ++s)
			{
				if (world->source [s] == columnId)
				{
					return world->name;
				}
			}
		}
		return TN_NONE;
	}

	const TinyWorld * TinyWorlds::FindWorld (Int3 columnId)
	{
		for (int idx = 0; idx < worlds.size (); ++idx)
		{
			const TinyWorld * world = worlds [idx];
			for (int s = 0; s < world->sourceCount; ++s)
			{
				if (world->source [s] == columnId)
				{
					return world;
				}
			}
		}
		return NULL;
	}
}