#pragma once

#include <vector>

namespace Ld {class ColumnMask;}
namespace SceneGfx {class World;}
namespace Tiny {class TinyWorld;}

namespace Tiny
{
	enum TINYITEMS
	{
		TI_AXE,
		TI_JUMP_1,
		TI_SHIELDCOLD,
		TI_BELT,
		TI_SHIELDHOT,
		TI_TELEPORTER,
		TI_JUMP_2,
		TI_SEEDS,
		TI_BIGAXE,

		TI_ARTIFACT,

		TI_NONE,
	};

	enum TINYNAMES
	{
		TN_HOME,
		TN_GRASS_01,
		TN_GRASS_02,
		TN_GRASS_03,
		TN_GRASS_04,
		TN_COLDWORLD,
		TN_VECTOR,
		TN_SUN,
		TN_DESERTWORLD,
		TN_ROBOTWORLD,
		TN_FIREWORLD,
		TN_ASTEROID,
		TN_ASTEROID_0,
		TN_ASTEROID_1,
		TN_ASTEROID_2,
		TN_ASTEROID_3,
		TN_ASTEROID_4,
		TN_ASTEROID_5,
		TN_ASTEROID_6,
		TN_ASTEROID_7,
		TN_ASTEROID_8,
		TN_ASTEROID_9,
		TN_ASTEROID_10,
		TN_ASTEROID_11,
		TN_ASTEROID_12,
		TN_SWAMP,
		TN_NONE,
	};

	class TinyWorlds
	{
	public:
		
		TinyWorlds (SceneGfx::World * gfxWorld);
		~TinyWorlds ();

		void Update ();
		void Render (Int3 columnId, Vec3 colRelPos);
		
		void SetMask (Ld::ColumnMask * columnMask);

		TINYITEMS FindItem (Int3 columnId) const;
		TINYNAMES FindName (Int3 columnId) const;

		const TinyWorld * FindWorld (Int3 columnId);
		
		std::vector <TinyWorld *> worlds;

		SceneGfx::World * gfxWorld;
	};
}