#pragma once

#include "SceneSim/SceneSim_Cell.h"

namespace CellMesh {class ShapeBase;}
namespace CellMesh {class Mngr;}
namespace Gfx {class Font;}
namespace Gfx {namespace VertexTypes {struct XyzUvRgb;}}
namespace SceneFile {class Command_BlockRecreate;}
namespace SceneGfx {class Column;}
namespace SceneSim {class Column;}

namespace CellMesh
{
	class AddShapeData
	{
	public:

		AddShapeData (
			int blockId,
			const SceneSim::AdjColumns * columns, 
			const CellMesh::Mngr * meshMngr,
			Gfx::VertexTypes::XyzUvRgb * verts,
			Gfx::VertexTypes::XyzUvRgb * extraVerts);

		const SceneSim::Cell * GetCell (Int3 cellId) const;
		const CellMesh::ShapeBase * GetShape (Int3 cellId) const;

		Gfx::VertexTypes::XyzUvRgb * verts;
		int vertsUsed;

		Gfx::VertexTypes::XyzUvRgb * extraVerts;
		int extraVertsUsed;

	private:

		//const SceneSim::Column * columnSrc;
		const CellMesh::Mngr * meshMngr;
		int blockId;

		//Int3 cellXyz;
		//const SceneSim::Cell * cell;

		Gfx::Font * font;

		SceneFile::Command_BlockRecreate * recreateBlock;

		SceneSim::Cell cells [SceneSim::CellsPerColXz + 2][SceneSim::CellsPerColY + 2][SceneSim::CellsPerColXz + 2];
		const CellMesh::ShapeBase * shapes [SceneSim::CellsPerColXz + 2][SceneSim::CellsPerColY + 2][SceneSim::CellsPerColXz + 2];
	};
}
