#include "stdafx.h"

#include "CellMesh_Mngr.h"
#include "CellMesh_ShapeBase.h"
#include "Shapes_Init.h"

namespace CellMesh
{
	int standard_rotations (int type, int data)
	{
		return (data & 3);
	}

	//int LadderMeshIdxFromCellData (int type, int data) 
	//{
	//	switch (data)
	//	{
	//	case 2: return 1;
	//	case 3: return 3;
	//	case 4: return 0;
	//	case 5: return 2;
	//	}
	//	assert (false);
	//	return 0;
	//}

	//int FurnaceMeshIdxFromCellData (int type, int data) 
	//{
	//	switch (data)
	//	{
	//	case 2: return 1;
	//	case 3: return 3;
	//	case 4: return 0;
	//	case 5: return 2;
	//	}
	//	assert (false);
	//	return 0;
	//}

	//int LeverMeshIdxFromCellData (int type, int data)
	//{
	//	switch (data & 0x7)
	//	{
	//	case 1: return 2;
	//	case 2: return 0;
	//	case 3: return 3;
	//	case 4: return 1;
	//	case 5: return 4;
	//	case 6: return 4;
	//	}
	//	assert (false);
	//	return 0;
	//}

	//int ButtonMeshIdxFromCellData (int type, int data)
	//{
	//	switch (data & 0x7)
	//	{
	//	case 1: return 0;
	//	case 2: return 2;
	//	case 3: return 1;
	//	case 4: return 3;
	//	}
	//	assert (false);
	//	return 0;
	//}

	//int PumpkinMeshIdxFromCellData (int type, int data) 
	//{
	//	switch (data)
	//	{
	//	case 0: return 1;
	//	case 1: return 2;
	//	case 2: return 3;
	//	case 3: return 0;
	//	}
	//	assert (false);
	//	return 0;
	//}

	//int waterSlabColours [1][6] =
	//{
	//	{14, 14, 14, 14, 14, 14}, // water
	//};

	//int lavaSlabColours [1][6] =
	//{
	//	{255, 255, 255, 255, 255, 255}, // lava
	//};

	//int slabColours [7][6] =
	//{
	//	{6, 6, 5, 5, 5, 5}, // stone
	//	{176, 208, 192, 192, 192, 192}, // sandstone
	//	{4, 4, 4, 4, 4, 4}, // wood
	//	{16, 16, 16, 16, 16, 16}, // cobblestone
	//	{7, 7, 7, 7, 7, 7}, // brick
	//	{54, 54, 54, 54, 54, 54}, // stone brick
	//	{6, 6, 6, 6, 6, 6}, // stone
	//};

	//int trunkColours [3][6] =
	//{
	//	{21, 21, 20, 20, 20, 20}, // normal
	//	{21, 21, 116, 116, 116, 116}, // spruce (dark)
	//	{21, 21, 117, 117, 117, 117}, // birch (light)
	//};

	//int woolColours [16][6] =
	//{
	//	{64, 64, 64, 64, 64, 64}, // white
	//	{210, 210, 210, 210, 210, 210}, // orange
	//	{194, 194, 194, 194, 194, 194}, // magenta
	//	{178, 178, 178, 178, 178, 178}, // light blue

	//	{162, 162, 162, 162, 162, 162}, // yellow
	//	{146, 146, 146, 146, 146, 146}, // light green
	//	{130, 130, 130, 130, 130, 130}, // pink
	//	{114, 114, 114, 114, 114, 114}, // gray

	//	{225, 225, 225, 225, 225, 225}, // light gray
	//	{209, 209, 209, 209, 209, 209}, // cyan
	//	{193, 193, 193, 193, 193, 193}, // purple
	//	{177, 177, 177, 177, 177, 177}, // blue

	//	{161, 161, 161, 161, 161, 161}, // brown
	//	{145, 145, 145, 145, 145, 145}, // dark green
	//	{129, 129, 129, 129, 129, 129}, // red
	//	{113, 113, 113, 113, 113, 113}, // black
	//};

	//int stoneBrickColours [3][6] =
	//{
	//	{101, 101, 101, 101, 101, 101}, // cracked
	//	{100, 100, 100, 100, 100, 100}, // mossy
	//	{54, 54, 54, 54, 54, 54}, // normal
	//};

	Mngr::Mngr ()
		: shapeTotal (256)
	{
		shapes = aah_new ShapeBase [shapeTotal];
		//memset (shapes, 0, sizeof (ShapeBase) * shapeTotal);

		//LuaState lua ("scripts/block_defs.lua");

		for (int idx = 1; idx < shapeTotal; ++idx)
		{
			Shapes::InitUnitCube (&shapes [idx], 9, 10, 8, 8, 8, 8); // tnt
			shapes [idx].gfxBlocking = GB_ALL;
		}

		shapes [0].gfxBlocking = GB_NONE; // air

		Shapes::InitUnitCube (&shapes [1], 255, 255, 255, 255, 255, 255); // scaffolding

		// home world

		Shapes::InitUnitCube (&shapes [2], 1, 1, 1, 1, 1, 1); // rock
		Shapes::InitUnitCube_CompassRotations (&shapes [3], 3, 2, 2, 3, 3, 3, standard_rotations); // computer screen
		Shapes::InitUnitCubeTrans (&shapes [4], 4, 4, 4, 4, 4, 4, CellMesh::GB_SAMETYPE); // glass
		Shapes::InitFence (&shapes [5], 5); // wood fence
		Shapes::InitFence (&shapes [6], 6); // metal fence
		Shapes::InitUnitCube (&shapes [7], 7, 7, 7, 7, 7, 7); // tree
		Shapes::InitCross (&shapes [8], 8); // tall grass 1
		Shapes::InitUnitCube (&shapes [9], 9, 9, 9, 9, 9, 9); // grass
		Shapes::InitUnitCube (&shapes [10], 9, 11, 10, 10, 10, 10); // grass + mud
		Shapes::InitUnitCube (&shapes [11], 11, 11, 11, 11, 11, 11); // mud

		Shapes::InitUnitCube_CompassRotations (&shapes [12], 128, 129, 130, 131, 132, 131, standard_rotations); // treasure chest

		Shapes::InitUnitCube (&shapes [13], 18, 18, 17, 17, 17, 17); // tree trunk

		Shapes::InitUnitCube_CompassRotations (&shapes [14], 133, 134, 135, 136, 137, 136, standard_rotations); // treasure chest

		Shapes::InitFence (&shapes [15], 12); // rock fence
		
		Shapes::InitUnitCube (&shapes [16], 19, 19, 19, 19, 19, 19); // wood plank
		Shapes::InitUnitCube (&shapes [17], 20, 20, 20, 20, 20, 20); // wood decor square
		Shapes::InitUnitCubeTrans (&shapes [18], 21, 21, 21, 21, 21, 21, CellMesh::GB_SAMETYPE); // wood decor square

		Shapes::InitUnitCube (&shapes [19], 112, 112, 112, 112, 112, 112); // sun
		shapes [19].isFullBright = true;

		Shapes::InitUnitCube (&shapes [20], 50, 50, 50, 50, 50, 50); // snow rock
		Shapes::InitUnitCube (&shapes [21], 49, 50, 51, 51, 51, 51); // snow rock + snow top
		Shapes::InitUnitCube (&shapes [22], 49, 50, 52, 52, 52, 52); // snow rock + double snow top
		Shapes::InitFence (&shapes [23], 53); // snow tree fence
		Shapes::InitUnitCube (&shapes [24], 54, 54, 55, 55, 55, 55); // snow tree leaves
		Shapes::InitUnitCube (&shapes [25], 56, 56, 56, 56, 56, 56); // snow crush block

		Shapes::InitUnitCube (&shapes [26], 97, 97, 98, 98, 98, 98); // vector main block
		Shapes::InitUnitCube (&shapes [27], 99, 99, 99, 99, 99, 99); // vector broken block
		Shapes::InitUnitCubeTrans (&shapes [28], 100, 100, 100, 100, 100, 100, CellMesh::GB_SAMETYPE); // vector glass
		Shapes::InitFence (&shapes [29], 101); // vector fence
		Shapes::InitCross (&shapes [30], 102); // vector tall grass 1
		Shapes::InitUnitCube (&shapes [31], 103, 97, 98, 98, 98, 98); // vector hint block

		Shapes::InitUnitCube (&shapes [32], 22, 1, 1, 1, 1, 1); // teleport block

		Shapes::InitUnitCube (&shapes [33], 32, 32, 32, 32, 32, 32); // sand block
		Shapes::InitUnitCube (&shapes [34], 36, 33, 33, 33, 33, 33); // pyramid
		Shapes::InitUnitCube (&shapes [35], 34, 34, 34, 34, 34, 34); // sand rock
		Shapes::InitUnitCube (&shapes [36], 35, 35, 35, 35, 35, 35); // sand rock bland
		Shapes::InitUnitCube (&shapes [37], 37, 33, 33, 33, 33, 33); // pyramid destroyable
		Shapes::InitUnitCube (&shapes [38], 38, 32, 32, 32, 32, 32); // sand jump block
		Shapes::InitFence (&shapes [39], 40); // sand fance
		Shapes::InitUnitCube (&shapes [40], 39, 32, 32, 32, 32, 32); // sand teleporter block
		Shapes::InitCross (&shapes [41], 41); // cactus
		
		Shapes::InitUnitCube (&shapes [42], 57, 57, 57, 57, 57, 57); // crumbly rock

		Shapes::InitUnitCube (&shapes [43], 66, 66, 66, 66, 66, 66); // swamp rock
		Shapes::InitUnitCubeTrans (&shapes [44], 68, 68, 68, 68, 68, 68, CellMesh::GB_NONE); // swamp vines square
		Shapes::InitCross (&shapes [45], 68); // swamp vines cross
		Shapes::InitUnitCube (&shapes [46], 69, 69, 69, 69, 69, 69); // swamp bricks
		Shapes::InitUnitCube (&shapes [47], 69, 69, 70, 70, 70, 70); // swamp bricks vines
		Shapes::InitUnitCube_CompassRotations (&shapes [48], 69, 69, 73, 69, 69, 69, standard_rotations); // clock tower
		Shapes::InitUnitCube_CompassRotations (&shapes [49], 69, 69, 74, 69, 69, 69, standard_rotations); // door 
		Shapes::InitUnitCube (&shapes [50], 71, 69, 72, 72, 72, 72); // roof
		Shapes::InitFence (&shapes [51], 75); // wood
		Shapes::InitUnitCube (&shapes [52], 77, 77, 77, 77, 77, 77); // leaves
		Shapes::InitUnitCube (&shapes [53], 78, 78, 78, 78, 78, 78); // leaves + vines
		Shapes::InitUnitCube (&shapes [54], 77, 78, 79, 79, 79, 79); // leaves + vines
		Shapes::InitUnitCube (&shapes [55], 76, 76, 76, 76, 76, 76); // trunk + vines

		Shapes::InitUnitCube (&shapes [56], 80, 80, 80, 80, 80, 80); // metal cube
		Shapes::InitUnitCubeTrans (&shapes [57], 81, 81, 81, 81, 81, 81, CellMesh::GB_NONE); // metal walkway
		Shapes::InitFence (&shapes [58], 82); // metal pole

		Shapes::InitUnitCube (&shapes [59], 83, 80, 80, 80, 80, 80); // metal seed hole
		Shapes::InitUnitCube (&shapes [60], 84, 80, 80, 80, 80, 80); // metal jump high thing
		Shapes::InitUnitCube (&shapes [61], 85, 87, 86, 86, 86, 86); // metal killer
		Shapes::InitUnitCube (&shapes [62], 88, 80, 80, 80, 80, 80); // metal teleporter

		Shapes::InitUnitCube_CompassRotations (&shapes [63], 144, 145, 146, 147, 148, 147, standard_rotations); // artifact chest

		Shapes::InitUnitCube (&shapes [64], 113, 113, 113, 113, 113, 113); // sun
		Shapes::InitUnitCube (&shapes [65], 114, 114, 114, 114, 114, 114); // sun
		Shapes::InitUnitCube (&shapes [66], 115, 115, 115, 115, 115, 115); // sun
		shapes [64].isFullBright = true;
		shapes [65].isFullBright = true;
		shapes [66].isFullBright = true;

		Shapes::InitUnitCubeTrans (&shapes [67], 89, 89, 89, 89, 89, 89, CellMesh::GB_NONE); // sun

		Shapes::InitUnitCube (&shapes [68], 104, 19, 19, 19, 19, 19); // wood plank teleporter


		//Shapes::InitUnitCube (&shapes [1], 1, 1, 1, 1, 1, 1); // stone
		//Shapes::InitUnitCube (&shapes [2], 0, 2, 3, 3, 3, 3); // grass 
		////Shapes::InitUnitCube (&shapes [2], 0 | addTint, 2, 3, 3, 3, 3); // grass
		//Shapes::InitUnitCube (&shapes [3], 2, 2, 2, 2, 2, 2); // dirt
		//Shapes::InitUnitCube (&shapes [4], 16, 16, 16, 16, 16, 16); // cobblestone

		//Shapes::InitUnitCube (&shapes [5], 4, 4, 4, 4, 4, 4); // woodenplank
		//Shapes::InitCross (&shapes [6], 15); // sapling
		//Shapes::InitUnitCube (&shapes [7], 17, 17, 17, 17, 17, 17); // bedrock
		////Shapes::InitUnitCube (&shapes [8], 189, 189, 189, 189, 189, 189); // water
		////Shapes::InitUnitCube (&shapes [9], 189, 189, 189, 189, 189, 189); // stationary water
		////Shapes::InitSlab (&shapes [8], waterSlabColours, 1); // water
		////Shapes::InitUnitCube (&shapes [9], 224, 224, 224, 224, 224, 224); // stationary water

		//Shapes::InitUnitCube (&shapes [8], 14, 14, 14, 14, 14, 14); // deep water
		//Shapes::InitSlab (&shapes [9], waterSlabColours, 1); // top water

		//Shapes::InitUnitCube (&shapes [10], 255, 255, 255, 255, 255, 255); // lava
		//Shapes::InitSlab (&shapes [11], lavaSlabColours, 1); // stationary lava
		//Shapes::InitUnitCube (&shapes [12], 18, 18, 18, 18, 18, 18); // sand
		//Shapes::InitUnitCube (&shapes [13], 19, 19, 19, 19, 19, 19); // gravel
		//Shapes::InitUnitCube (&shapes [14], 32, 32, 32, 32, 32, 32); // gold ore

		//Shapes::InitUnitCube (&shapes [15], 33, 33, 33, 33, 33, 33); // iron ore
		//Shapes::InitUnitCube (&shapes [16], 34, 34, 34, 34, 34, 34); // coal ore
		//Shapes::InitUnitCube_Textures (&shapes [17], trunkColours, 3); // wood trunk
		//Shapes::InitUnitCubeTrans (&shapes [18], 52, 52, 52, 52, 52, 52, CellMesh::GB_NONE); // leaves
		////Shapes::InitUnitCubeTrans (&shapes [18], 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, CellMesh::GB_NONE); // leaves
		//Shapes::InitUnitCube (&shapes [19], 48, 48, 48, 48, 48, 48); // sponge

		//Shapes::InitUnitCubeTrans (&shapes [20], 49, 49, 49, 49, 49, 49, CellMesh::GB_SAMETYPE); // glass
		//Shapes::InitUnitCube (&shapes [21], 160, 160, 160, 160, 160, 160); // lapis luzali ore
		//Shapes::InitUnitCube (&shapes [22], 144, 144, 144, 144, 144, 144); // lapis luzali block
		//Shapes::InitUnitCube (&shapes [23], 62, 62, 183, 183, 183, 183); // dispenser
		//Shapes::InitUnitCube (&shapes [24], 176, 208, 192, 192, 192, 192); // sandstone

		//Shapes::InitUnitCube (&shapes [25], 74, 74, 74, 74, 74, 74); // note block
		//Shapes::InitUnitCube (&shapes [26], 129, 129, 129, 129, 129, 129); // temporary bed
		////Shapes::InitBox (&shapes [26], 135, -1, 152, 151, -1, 151, Int3 (0, 7, 0), Int3 (16, 16, 16)); // bed
		//Shapes::InitPoweredRailway (&shapes [27], 179, 163); // powered rail
		//Shapes::InitDetectorRailway (&shapes [28], 195); // detector rail
		//Shapes::InitPistonBase (&shapes [29], 106, 109, 108, 110); // sticky piston base

		////Shapes::InitUnitCube (&shapes [30], ); // web
		//Shapes::InitCross (&shapes [31], 39); // tall grass
		//Shapes::InitCross (&shapes [32], 55); // dead bush
		//Shapes::InitPistonBase (&shapes [33], 107, 109, 108, 110); // normal piston base
		//Shapes::InitPistonHead (&shapes [34], 106, 107, 108, 4); // piston head

		//Shapes::InitUnitCube_Textures (&shapes [35], woolColours, 16); // wool
		////Shapes::InitUnitCube (&shapes [36], ); // 
		//Shapes::InitCross (&shapes [37], 13); // dandelion
		//Shapes::InitCross (&shapes [38], 12); // rose
		//Shapes::InitCross (&shapes [39], 29); // brown mushroom

		//Shapes::InitCross (&shapes [40], 28); // red mushroom
		//Shapes::InitUnitCube (&shapes [41], 23, 23, 23, 23, 23, 23); // gold block
		//Shapes::InitUnitCube (&shapes [42], 22, 22, 22, 22, 22, 22); // iron block
		//Shapes::InitUnitCube_Textures (&shapes [43], slabColours, 7); // double slab
		//Shapes::InitSlab (&shapes [44], slabColours, 7); // slab

		//Shapes::InitUnitCube (&shapes [45], 7, 7, 7, 7, 7, 7); // brick block
		//Shapes::InitUnitCube (&shapes [46], 9, 10, 8, 8, 8, 8); // tnt
		//Shapes::InitUnitCube (&shapes [47], 4, 4, 35, 35, 35, 35); // bookshelf
		//Shapes::InitUnitCube (&shapes [48], 36, 36, 36, 36, 36, 36); // moss stone
		//Shapes::InitUnitCube (&shapes [49], 37, 37, 37, 37, 37, 37); // obsidian

		//Shapes::InitTorch (&shapes [50], 80); // torch
		//Shapes::InitCross (&shapes [51], 31); // fire
		//Shapes::InitUnitCubeTrans (&shapes [52], 65, 65, 65, 65, 65, 65, GB_NONE); // monster spawner
		//Shapes::InitStairs (&shapes [53], 4); // wooden stairs
		//Shapes::InitUnitCube (&shapes [54], 25, 25, 27, 26, 26, 26); // chest

		//Shapes::InitWire (&shapes [55], 165, 164); // redstone wire
		//Shapes::InitUnitCube (&shapes [56], 50, 50, 50, 50, 50, 50); // diamond ore
		//Shapes::InitUnitCube (&shapes [57], 24, 24, 24, 24, 24, 24); // diamond block
		//Shapes::InitUnitCube (&shapes [58], 43, 43, 59, 60, 59, 60); // crafting table
		//Shapes::InitCross (&shapes [59], 95); // seeds

		//Shapes::InitBox (&shapes [60], 86, 2, 2, 2, 2, 2, Int3 (0, 0, 0), Int3 (16, 15, 16), SceneSim::FF_B); // farmland
		//Shapes::InitUnitCube_CompassRotations (&shapes [61], 62, 62, 44, 45, 45, 45, FurnaceMeshIdxFromCellData); // furnace
		//Shapes::InitUnitCube_CompassRotations (&shapes [62], 62, 62, 61, 45, 45, 45, FurnaceMeshIdxFromCellData); // burning furnace
		//Shapes::InitSign (&shapes [63], 4); // sign post
		//Shapes::InitDoor (&shapes [64], 81, 97); // wooden door

		//Shapes::InitBox_CompassRotations (&shapes [65], -1, -1, 83, -1, -1, -1, Int3 (0, 0, 15), Int3 (16, 16, 1), LadderMeshIdxFromCellData); // ladder
		//Shapes::InitRailway (&shapes [66], 128, 112); // railway
		//Shapes::InitStairs (&shapes [67], 16); // cobblestone stairs
		//Shapes::InitWallSign (&shapes [68], 4); // wall sign
		////UvSet_InitBoxRotated (&uvSets [69], 16, 16, 16, 16, 16, 16, Int3 (5, 4, 0), Int3 (11, 12, 3), leverRotations); // lever
		//Shapes::InitBox_CompassDownRotations (&shapes [69], 16, 16, 16, 16, 16, 16, Int3 (5, 4, 0), Int3 (11, 12, 3), LeverMeshIdxFromCellData); // stone button

		//Shapes::InitBox (&shapes [70], 1, -1, 1, 1, 1, 1, Int3 (1, 0, 1), Int3 (15, 1, 15), 0); // wooden pressure plate
		//Shapes::InitDoor (&shapes [71], 82, 98); // iron door
		//Shapes::InitBox (&shapes [72], 4, -1, 4, 4, 4, 4, Int3 (1, 0, 1), Int3 (15, 1, 15), 0); // stone pressure plate
		//Shapes::InitUnitCube (&shapes [73], 51, 51, 51, 51, 51, 51); // redstone ore
		//Shapes::InitUnitCube (&shapes [74], 51, 51, 51, 51, 51, 51); // glowing redstone ore

		//Shapes::InitTorch (&shapes [75], 115); // redstone torch (off)
		//Shapes::InitTorch (&shapes [76], 99); // redstone torch (on)
		//Shapes::InitBox_CompassRotations (&shapes [77], 1, 1, -1, 1, 1, 1, Int3 (5, 6, 14), Int3 (11, 10, 16), ButtonMeshIdxFromCellData); // stone button
		//Shapes::InitBox (&shapes [78], 66, 66, 66, 66, 66, 66, Int3 (0, 0, 0), Int3 (16, 2, 16), SceneSim::FF_B); // snow
		//Shapes::InitUnitCube (&shapes [79], 67, 67, 67, 67, 67, 67); // ice

		//Shapes::InitUnitCube (&shapes [80], 66, 66, 66, 66, 66, 66); // snow block
		//Shapes::InitBox_Transparent (&shapes [81], 69, 71, 70, 70, 70, 70, Int3 (1, 0, 1), Int3 (15, 16, 15)); // cactus
		//Shapes::InitUnitCube (&shapes [82], 72, 72, 72, 72, 72, 72); // clay block
		//Shapes::InitCross (&shapes [83], 73); // sugar cane
		//Shapes::InitUnitCube (&shapes [84], 75, 74, 74, 74, 74, 74); // jukebox

		//Shapes::InitFence (&shapes [85], 4); // fence
		//Shapes::InitUnitCube_CompassRotations (&shapes [86], 102, 102, 119, 118, 118, 118, PumpkinMeshIdxFromCellData); // pumpkin
		//Shapes::InitUnitCube (&shapes [87], 103, 103, 103, 103, 103, 103); // netherrack
		//Shapes::InitUnitCube (&shapes [88], 104, 104, 104, 104, 104, 104); // soul sand
		//Shapes::InitUnitCube (&shapes [89], 105, 105, 105, 105, 105, 105); // glowstone

		////Shapes::InitUnitCube (&shapes [90], ); // portal
		//Shapes::InitUnitCube_CompassRotations (&shapes [91], 102, 102, 120, 118, 118, 118, PumpkinMeshIdxFromCellData); // jack-o-lantern
		//Shapes::InitBox (&shapes [92], 121, 124, 122, 122, 122, 122, Int3 (1, 0, 1), Int3 (15, 7, 15), 0); // cake

		//// new blocks

		//Shapes::InitBox (&shapes [96], 84, 84, 25, 25, 25, 25, Int3 (0, 0, 0), Int3 (16, 3, 16), 0); // hatch
		//Shapes::InitUnitCube_Textures (&shapes [98], stoneBrickColours, 3); // stone brick
		//Shapes::InitUnitCube (&shapes [103], 137, 137, 136, 136, 136, 136); // melon
		//Shapes::InitCross (&shapes [104], 111); // pumpkin stem
		//Shapes::InitCross (&shapes [105], 111); // melon stem
		//Shapes::InitGate (&shapes [107], 4); // gate
		//Shapes::InitStairs (&shapes [108], 7); // brick stairs
		//Shapes::InitStairs (&shapes [109], 54); // stone brick stairs
		//Shapes::InitBox (&shapes [111], 76, -1, -1, -1, -1, -1, Int3 (0, -8, 0), Int3 (16, -7, 16), 0); // lily
		//Shapes::InitUnitCube (&shapes [128], 66, 2, 68, 68, 68, 68); // cobblestone	
		//Shapes::InitSlope (&shapes [129], 4); // wood slope
		//Shapes::InitSlope (&shapes [130], 16); // cobblestone slope
	}

	Mngr::~Mngr ()
	{
		delete [] shapes;
	}

	const ShapeBase * Mngr::GetShape (int shapeId) const
	{
		if (shapeId >= shapeTotal || shapeId < 0)
		{
			assert (false);
			return NULL;
		}

		return &shapes [shapeId];
	}

	ShapeBase * Mngr::GetShape (int shapeId)
	{
		if (shapeId >= shapeTotal || shapeId < 0)
		{
			assert (false);
			return NULL;
		}

		return &shapes [shapeId];
	}
}
