#include "stdafx.h"
/*
//#include "../Gfx/Gfx_Font.h"

#include "CellBuilder_Mngr.h"
#include "CellMesh_ShapeBase.h"
#include "Shapes_Init.h"

namespace CellMesh
{
	int LadderMeshIdxFromCellData (int type, int data) 
	{
		switch (data)
		{
		case 2: return 1;
		case 3: return 3;
		case 4: return 0;
		case 5: return 2;
		}
		assert (false);
		return 0;
	}

	int FurnaceMeshIdxFromCellData (int type, int data) 
	{
		switch (data)
		{
		case 2: return 1;
		case 3: return 3;
		case 4: return 0;
		case 5: return 2;
		}
		assert (false);
		return 0;
	}

	int LeverMeshIdxFromCellData (int type, int data)
	{
		switch (data & 0x7)
		{
		case 1: return 2;
		case 2: return 0;
		case 3: return 3;
		case 4: return 1;
		case 5: return 4;
		case 6: return 4;
		}
		assert (false);
		return 0;
	}

	int ButtonMeshIdxFromCellData (int type, int data)
	{
		switch (data & 0x7)
		{
		case 1: return 0;
		case 2: return 2;
		case 3: return 1;
		case 4: return 3;
		}
		assert (false);
		return 0;
	}

	int PumpkinMeshIdxFromCellData (int type, int data) 
	{
		switch (data)
		{
		case 0: return 1;
		case 1: return 2;
		case 2: return 3;
		case 3: return 0;
		}
		assert (false);
		return 0;
	}

	int slabColours [4][6] =
	{
		{6, 6, 5, 5, 5, 5}, // stone
		{18, 18, 176, 176, 176, 176}, // sandstone
		{4, 4, 4, 4, 4, 4}, // wood
		{16, 16, 16, 16, 16, 16}, // cobblestone
	};

	int trunkColours [3][6] =
	{
		{21, 21, 20, 20, 20, 20}, // normal
		{21, 21, 116, 116, 116, 116}, // spruce (dark)
		{21, 21, 117, 117, 117, 117}, // birch (light)
	};

	int woolColours [16][6] =
	{
		{64, 64, 64, 64, 64, 64}, // white
		{210, 210, 210, 210, 210, 210}, // orange
		{194, 194, 194, 194, 194, 194}, // magenta
		{178, 178, 178, 178, 178, 178}, // light blue

		{162, 162, 162, 162, 162, 162}, // yellow
		{146, 146, 146, 146, 146, 146}, // light green
		{130, 130, 130, 130, 130, 130}, // pink
		{114, 114, 114, 114, 114, 114}, // gray

		{225, 225, 225, 225, 225, 225}, // light gray
		{209, 209, 209, 209, 209, 209}, // cyan
		{193, 193, 193, 193, 193, 193}, // purple
		{177, 177, 177, 177, 177, 177}, // blue

		{161, 161, 161, 161, 161, 161}, // brown
		{145, 145, 145, 145, 145, 145}, // dark green
		{129, 129, 129, 129, 129, 129}, // red
		{113, 113, 113, 113, 113, 113}, // black
	};

	Mngr::Mngr ()
		: shapeTotal (256)
	{
		shapes = aah_new ShapeBase [shapeTotal];
		for (int idx = 1; idx < shapeTotal; ++idx)
		{
			Shapes::InitUnitCube (&shapes [idx], 9, 10, 8, 8, 8, 8); // tnt
		}

		shapes [0].entCollisions = EC_NONE; // air
		shapes [0].gfxBlocking = CellMesh::GB_NONE; // air

		Shapes::InitUnitCube (&shapes [1], 1, 1, 1, 1, 1, 1); // stone
		Shapes::InitUnitCube (&shapes [2], 0, 2, 3, 3, 3, 3); // grass
		Shapes::InitUnitCube (&shapes [3], 2, 2, 2, 2, 2, 2); // dirt
		Shapes::InitUnitCube (&shapes [4], 16, 16, 16, 16, 16, 16); // cobblestone

		Shapes::InitUnitCube (&shapes [5], 4, 4, 4, 4, 4, 4); // woodenplank
		Shapes::InitCross (&shapes [6], 15); // sapling
		Shapes::InitUnitCube (&shapes [7], 17, 17, 17, 17, 17, 17); // bedrock
		//Shapes::InitUnitCube (&shapes [8], 189, 189, 189, 189, 189, 189); // water
		Shapes::InitUnitCube (&shapes [8], 144, 144, 144, 144, 144, 144); // water
		Shapes::InitUnitCube (&shapes [9], 189, 189, 189, 189, 189, 189); // stationary water

		Shapes::InitUnitCube (&shapes [10], 255, 255, 255, 255, 255, 255); // lava
		Shapes::InitUnitCube (&shapes [11], 255, 255, 255, 255, 255, 255); // stationary lava
		Shapes::InitUnitCube (&shapes [12], 18, 18, 18, 18, 18, 18); // sand
		Shapes::InitUnitCube (&shapes [13], 19, 19, 19, 19, 19, 19); // gravel
		Shapes::InitUnitCube (&shapes [14], 32, 32, 32, 32, 32, 32); // gold ore

		Shapes::InitUnitCube (&shapes [15], 33, 33, 33, 33, 33, 33); // iron ore
		Shapes::InitUnitCube (&shapes [16], 34, 34, 34, 34, 34, 34); // coal ore
		Shapes::InitUnitCube_Textures (&shapes [17], trunkColours, 3); // wood trunk
		Shapes::InitUnitCubeTrans (&shapes [18], 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, 52 | addTint, CellMesh::GB_NONE); // leaves
		Shapes::InitUnitCube (&shapes [19], 48, 48, 48, 48, 48, 48); // sponge

		Shapes::InitUnitCubeTrans (&shapes [20], 49, 49, 49, 49, 49, 49, CellBuilder::GB_SAMETYPE); // glass
		Shapes::InitUnitCube (&shapes [21], 160, 160, 160, 160, 160, 160); // lapis luzali ore
		Shapes::InitUnitCube (&shapes [22], 144, 144, 144, 144, 144, 144); // lapis luzali block
		Shapes::InitUnitCube (&shapes [23], 62, 62, 183, 183, 183, 183); // dispenser
		Shapes::InitUnitCube (&shapes [24], 18, 18, 176, 176, 176, 176); // sandstone

		Shapes::InitUnitCube (&shapes [25], 74, 74, 74, 74, 74, 74); // note block
		Shapes::InitUnitCube (&shapes [26], 129, 129, 129, 129, 129, 129); // temporary bed
		//Shapes::InitBox (&shapes [26], 135, -1, 152, 151, -1, 151, Int3 (0, 7, 0), Int3 (16, 16, 16)); // bed
		//Shapes::InitUnitCube (&shapes [27], ); // powered rail
		//Shapes::InitUnitCube (&shapes [28], ); // detector rail
		//Shapes::InitUnitCube (&shapes [29], ); // 

		//Shapes::InitUnitCube (&shapes [30], ); // web
		//Shapes::InitUnitCube (&shapes [31], ); // 
		//Shapes::InitUnitCube (&shapes [32], ); // 
		//Shapes::InitUnitCube (&shapes [33], ); // 
		//Shapes::InitUnitCube (&shapes [34], ); // 

		Shapes::InitUnitCube_Textures (&shapes [35], woolColours, 16); // wool
		//Shapes::InitUnitCube (&shapes [36], ); // 
		Shapes::InitCross (&shapes [37], 13); // dandelion
		Shapes::InitCross (&shapes [38], 12); // rose
		Shapes::InitCross (&shapes [39], 29); // brown mushroom

		Shapes::InitCross (&shapes [40], 28); // red mushroom
		Shapes::InitUnitCube (&shapes [41], 23, 23, 23, 23, 23, 23); // gold block
		Shapes::InitUnitCube (&shapes [42], 22, 22, 22, 22, 22, 22); // iron block
		Shapes::InitUnitCube_Textures (&shapes [43], slabColours, 4); // double slab
		Shapes::InitSlab (&shapes [44], slabColours, 4); // slab

		Shapes::InitUnitCube (&shapes [45], 7, 7, 7, 7, 7, 7); // brick block
		Shapes::InitUnitCube (&shapes [46], 9, 10, 8, 8, 8, 8); // tnt
		Shapes::InitUnitCube (&shapes [47], 4, 4, 35, 35, 35, 35); // bookshelf
		Shapes::InitUnitCube (&shapes [48], 36, 36, 36, 36, 36, 36); // moss stone
		Shapes::InitUnitCube (&shapes [49], 37, 37, 37, 37, 37, 37); // obsidian

		Shapes::InitTorch (&shapes [50], 80); // torch
		Shapes::InitCross (&shapes [51], 31); // fire
		Shapes::InitUnitCube (&shapes [52], 65, 65, 65, 65, 65, 65); // monster spawner
		Shapes::InitStairs (&shapes [53], 4); // wooden stairs
		Shapes::InitUnitCube (&shapes [54], 25, 25, 27, 26, 26, 26); // chest

		Shapes::InitWire (&shapes [55], 165, 164); // redstone wire
		Shapes::InitUnitCube (&shapes [56], 50, 50, 50, 50, 50, 50); // diamond ore
		Shapes::InitUnitCube (&shapes [57], 24, 24, 24, 24, 24, 24); // diamond block
		Shapes::InitUnitCube (&shapes [58], 43, 43, 59, 60, 59, 60); // crafting table
		Shapes::InitCross (&shapes [59], 89); // seeds

		Shapes::InitBox (&shapes [60], 87, 2, 2, 2, 2, 2, Int3 (0, 0, 0), Int3 (16, 15, 16)); // farmland
		Shapes::InitUnitCube_CompassRotations (&shapes [61], 62, 62, 44, 45, 45, 45, FurnaceMeshIdxFromCellData); // furnace
		Shapes::InitUnitCube_CompassRotations (&shapes [62], 62, 62, 61, 45, 45, 45, FurnaceMeshIdxFromCellData); // burning furnace
		Shapes::InitSign (&shapes [63], 4); // sign post
		Shapes::InitDoor (&shapes [64], 81, 97); // wooden door

		Shapes::InitBox_CompassRotations (&shapes [65], -1, -1, 83, -1, -1, -1, Int3 (0, 0, 15), Int3 (16, 16, 1), LadderMeshIdxFromCellData); // ladder
		Shapes::InitRailway (&shapes [66], 128, 112); // railway
		Shapes::InitStairs (&shapes [67], 16); // cobblestone stairs
		Shapes::InitWallSign (&shapes [68], 4); // wall sign
		//UvSet_InitBoxRotated (&uvSets [69], 16, 16, 16, 16, 16, 16, Int3 (5, 4, 0), Int3 (11, 12, 3), leverRotations); // lever
		Shapes::InitBox_CompassDownRotations (&shapes [69], 16, 16, 16, 16, 16, 16, Int3 (5, 4, 0), Int3 (11, 12, 3), LeverMeshIdxFromCellData); // stone button

		Shapes::InitBox (&shapes [70], 1, -1, 1, 1, 1, 1, Int3 (1, 0, 1), Int3 (15, 1, 15)); // wooden pressure plate
		Shapes::InitDoor (&shapes [71], 82, 98); // iron door
		Shapes::InitBox (&shapes [72], 4, -1, 4, 4, 4, 4, Int3 (1, 0, 1), Int3 (15, 1, 15)); // stone pressure plate
		Shapes::InitUnitCube (&shapes [73], 51, 51, 51, 51, 51, 51); // redstone ore
		Shapes::InitUnitCube (&shapes [74], 51, 51, 51, 51, 51, 51); // glowing redstone ore

		Shapes::InitTorch (&shapes [75], 115); // redstone torch (off)
		Shapes::InitTorch (&shapes [76], 99); // redstone torch (on)
		Shapes::InitBox_CompassRotations (&shapes [77], 1, 1, -1, 1, 1, 1, Int3 (5, 6, 14), Int3 (11, 10, 16), ButtonMeshIdxFromCellData); // stone button
		Shapes::InitBox (&shapes [78], 66, 66, 66, 66, 66, 66, Int3 (0, 0, 0), Int3 (16, 2, 16)); // snow
		Shapes::InitUnitCube (&shapes [79], 67, 67, 67, 67, 67, 67); // ice

		Shapes::InitUnitCube (&shapes [80], 66, 66, 66, 66, 66, 66); // snow block
		Shapes::InitBox_Transparent (&shapes [81], 69, 71, 70, 70, 70, 70, Int3 (1, 0, 1), Int3 (15, 16, 15)); // cactus
		shapes [81].entCollisions = EC_UNITCUBE; // cactus

		Shapes::InitUnitCube (&shapes [82], 72, 72, 72, 72, 72, 72); // clay block
		Shapes::InitCross (&shapes [83], 73); // sugar cane
		Shapes::InitUnitCube (&shapes [84], 75, 74, 74, 74, 74, 74); // jukebox

		Shapes::InitFence (&shapes [85], 4); // fence
		Shapes::InitUnitCube_CompassRotations (&shapes [86], 102, 102, 119, 118, 118, 118, PumpkinMeshIdxFromCellData); // pumpkin
		Shapes::InitUnitCube (&shapes [87], 103, 103, 103, 103, 103, 103); // netherrack
		Shapes::InitUnitCube (&shapes [88], 104, 104, 104, 104, 104, 104); // soul sand
		Shapes::InitUnitCube (&shapes [89], 105, 105, 105, 105, 105, 105); // glowstone

		////Shapes::InitUnitCube (&shapes [90], ); // portal
		Shapes::InitUnitCube_CompassRotations (&shapes [91], 102, 102, 120, 118, 118, 118, PumpkinMeshIdxFromCellData); // jack-o-lantern
		Shapes::InitBox (&shapes [92], 121, 124, 122, 122, 122, 122, Int3 (1, 0, 1), Int3 (15, 7, 15)); // cake

		// new blocks
		Shapes::InitUnitCube (&shapes [128], 66, 2, 68, 68, 68, 68); // cobblestone

		font = aah_new Gfx::Font ("fonts/nokia_medium.glf");
	}

	Mngr::~Mngr ()
	{
	}

	const ShapeBase * Mngr::GetShape (int shapeId) const
	{
		if (shapeId >= shapeTotal || shapeId < 0)
		{
			assert (false);
			return NULL;
		}

		return &shapes [shapeId];
	}
}
*/