#pragma once

namespace CellMesh {class ShapeBase;}

namespace CellMesh
{
	namespace Shapes
	{
		extern void InitBox (ShapeBase * shape, int t, int b, int n, int e, int s, int w, Int3 min, Int3 max, int canBlockFaces);
		extern void InitBox_CompassDownRotations (ShapeBase * shape, int t, int b, int n, int e, int s, int w, Int3 min, Int3 max, MeshIdxFromCellDataFuncPtr meshIdxFuncPtr);
		extern void InitBox_CompassRotations (ShapeBase * shape, int t, int b, int n, int e, int s, int w, Int3 min, Int3 max, MeshIdxFromCellDataFuncPtr meshIdxFuncPtr);
		extern void InitBox_Transparent (ShapeBase * shape, int t, int b, int n, int e, int s, int w, Int3 min, Int3 max);
		extern void InitCross (ShapeBase * shape, int tex);
		extern void InitDoor (ShapeBase * shape, int texB, int texT);
		extern void InitFence (ShapeBase * shape, int tex);
		extern void InitGate (ShapeBase * shape, int tex);
		extern void InitRailway (ShapeBase * shape, int texStraight, int texCorner);
		extern void InitPoweredRailway (ShapeBase * shape, int texPowered, int texUnpowered);
		extern void InitDetectorRailway (ShapeBase * shape, int texStraight);
		extern void InitPistonBase (ShapeBase * shape, int t, int b, int sides, int mech);
		extern void InitPistonHead (ShapeBase * shape, int sticky, int normal, int sides, int stem);
		extern void InitSign (ShapeBase * shape, int tex);
		extern void InitSlab (ShapeBase * shape, int tex [][6], int variantCount);
		extern void InitSlope (ShapeBase * shape, int tex);
		extern void InitStairs (ShapeBase * shape, int tex);
		extern void InitTorch (ShapeBase * shape, int tex);
		extern void InitUnitCube (ShapeBase * shape, int t, int b, int n, int e, int s, int w);
		extern void InitUnitCubeTrans (ShapeBase * shape, int t, int b, int n, int e, int s, int w, GFXBLOCKINGS gfxBlocking);
		extern void InitUnitCube_CompassRotations (ShapeBase * shape, int t, int b, int n, int e, int s, int w, MeshIdxFromCellDataFuncPtr meshIdxFuncPtr);
		extern void InitUnitCube_Textures (ShapeBase * shape, int tex [][6], int variantCount);
		extern void InitWallSign (ShapeBase * shape, int tex);
		extern void InitWire (ShapeBase * shape, int texLine, int texCross);
	}
}
