#include "stdafx.h"

#include "Shapes_InitData.h"

namespace CellMesh
{
	InitData::InitData (int meshTotal, int trisPerMeshTotal, int hasFaces, int canBlockFaces)
		: isSingleTypeMesh (true),
		meshTotal (meshTotal),
		meshIdxFromCellDataFuncPtr (NULL),
		awfulCalcDataFuncPtr (NULL),
		newAddExtraStuff (NULL)
	{
		perMesh = aah_new PerMesh [meshTotal];

		for (int idx = 0; idx < meshTotal; ++idx)
		{
			perMesh [idx].trisPerMeshTotal = trisPerMeshTotal;

			perMesh [idx].triFacings = aah_new SceneSim::FACES [trisPerMeshTotal];
			perMesh [idx].triLightMappings = aah_new SceneSim::FACES [trisPerMeshTotal];
			perMesh [idx].triTexIds = aah_new int [trisPerMeshTotal];
			
			perMesh [idx].hasFaces = hasFaces;
			perMesh [idx].canBlockAdjFaces = canBlockFaces;
			perMesh [idx].currentTriIdx = 0;
		}
	}

	InitData::InitData (int meshTotal, const int * trisPerMeshTotal, const int * hasFaces)
		: isSingleTypeMesh (false),
		meshTotal (meshTotal),
		meshIdxFromCellDataFuncPtr (NULL),
		awfulCalcDataFuncPtr (NULL),
		newAddExtraStuff (NULL)
	{
		perMesh = aah_new PerMesh [meshTotal];

		for (int idx = 0; idx < meshTotal; ++idx)
		{
			int trisPerMesh = trisPerMeshTotal [idx];

			perMesh [idx].trisPerMeshTotal = trisPerMesh;

			perMesh [idx].triFacings = aah_new SceneSim::FACES [trisPerMesh];
			perMesh [idx].triLightMappings = aah_new SceneSim::FACES [trisPerMesh];
			perMesh [idx].triTexIds = aah_new int [trisPerMesh];
			
			perMesh [idx].hasFaces = hasFaces [idx];
			perMesh [idx].canBlockAdjFaces = 0;
			perMesh [idx].currentTriIdx = 0;
		}
	}

	InitData::~InitData ()
	{
		for (int idx = 0; idx < meshTotal; ++idx)
		{
			delete [] perMesh [idx].triFacings;
			delete [] perMesh [idx].triLightMappings;
			delete [] perMesh [idx].triTexIds;
		}
		delete [] perMesh;
	}
}
