#pragma once

#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	struct InitData
	{
		InitData (int meshTotal, int trisPerMeshTotal, int hasFaces, int canBlockFaces);
		InitData (int meshTotal, const int * trisPerMeshTotal, const int * hasFaces);
		~InitData ();

		const bool isSingleTypeMesh;

		int meshTotal;
		MeshIdxFromCellDataFuncPtr meshIdxFromCellDataFuncPtr;
		AwfulCalcDataFuncPtr awfulCalcDataFuncPtr;
		NewAddExtraStuff newAddExtraStuff;

		struct PerMesh
		{
			SceneSim::FACES * triFacings;
			SceneSim::FACES * triLightMappings;
			int * triTexIds;

			int trisPerMeshTotal;
			int hasFaces;
			int canBlockAdjFaces;

			int currentTriIdx;
		};

		PerMesh * perMesh;
	};
}