#include "stdafx.h"

#include "SceneSim/BlockData_Sign.h"
#include "SceneSim/SceneSim_Cell.h"
#include "SceneSim/SceneSim_Column.h"

#include "../Gfx/Gfx_Font.h"
#include "../Gfx/VertexTypes_XyzUvRgb.h"
#include "../SceneGfx/SceneGfx_Column.h"

#include "Shapes_InitData.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		int CalcSignMeshIdx (int type, int data)
		{
			return (data + 12) % 16;
		}

		Vec3 SignRotation (Mat44 * rotation, Vec3 toRotate)
		{

			Vec4 srcPos = Vec4 (toRotate.x, toRotate.y, toRotate.z, 0.0f);
			srcPos = (*rotation) * srcPos;

			return Vec3 (srcPos.x, srcPos.y, srcPos.z);
		}

		int SignAddExtraStuff (AddShapeData * addData, int triIdx)
		{
			return 0;
			//const int idx = CalcSignMeshIdx (addData->cell->type, addData->cell->blockData);

			//Mat44 rotation = glm::rotate (Mat44 (), (idx * 360.0f / 16.0f), Vec3 (0.0f, 1.0f, 0.0f));

			//int triCount = 0;
			//float pixel = 0.005f;
			//float distFromSign = 1.05f / 16.0f;

			//Vec3 origin (0.0f, 0.0f, distFromSign);
			//Vec3 cr (0.0f, -0.1f, 0.0f);
			//Vec3 dx (-pixel, 0.0f, 0.0f);
			//Vec3 dy (0.0f, pixel, 0.0f);

			//origin = SignRotation (&rotation, origin) + Vec3 (0.5f, 0.85f, 0.5f);
			//dx = SignRotation (&rotation, dx);

			//Gfx::VertexTypes::XyzUvRgb * verts = &addData->extraVerts [triIdx * 3];

			////Int3 colRel (addData->block->ColRelIdFromBlockRelId(addData->cellXyz));
			//Int3 colRel (addData->cellXyz);

			////std::cout << "FIND = " << colRel.x << ", " << colRel.y << ", " << colRel.z << ", " << std::endl;

			//SceneSim::BlockData::Sign * sign = addData->column->GetSim ()->BlockData_GetSign (colRel);
			//if (sign == NULL)
			//{
			//	return 0;
			//}

			//// 14 wide
			//triCount += addData->font->AddTris (sign->text [0], verts + (triCount * 3), origin, dx, dy);
			//origin += cr;

			//triCount += addData->font->AddTris (sign->text [1], verts + (triCount * 3), origin, dx, dy);
			//origin += cr;

			//triCount += addData->font->AddTris (sign->text [2], verts + (triCount * 3), origin, dx, dy);
			//origin += cr;

			//triCount += addData->font->AddTris (sign->text [3], verts + (triCount * 3), origin, dx, dy);

			//return triCount;
		}

		void InitSign (ShapeBase * shape, int tex)
		{			
			const float unit = 1.0f / 16.0f;

			InitData data (16, 20, SceneSim::FF_OTHER, 0);
			data.meshIdxFromCellDataFuncPtr = CalcSignMeshIdx;
			data.newAddExtraStuff = SignAddExtraStuff;

			shape->Init (&data, tex);

			//shape->entCollisions = SceneSim::EC_NONE;
			shape->gfxBlocking = CellMesh::GB_NONE;

			// top
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, unit * 9.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -unit * 2.0f), SceneSim::F_T, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, unit * 8.0f, unit * 7.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, unit * 2.0f), SceneSim::F_B, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (1.0f, 1.0f, unit * 9.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_N, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (1.0f, 1.0f, unit * 7.0f), Vec3 (0.0f, 0.0f, unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_E, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, unit * 7.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_S, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, unit * 9.0f), Vec3 (0.0f, 0.0f, -unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_W, tex);

			// support
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (unit * 9.0f, unit * 8.0f, unit * 9.0f), Vec3 (-unit * 2.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_N, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (unit * 9.0f, unit * 8.0f, unit * 7.0f), Vec3 (0.0f, 0.0f, unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_E, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (unit * 7.0f, unit * 8.0f, unit * 7.0f), Vec3 (unit * 2.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_S, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (unit * 7.0f, unit * 8.0f, unit * 9.0f), Vec3 (0.0f, 0.0f, -unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_W, tex);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);

			for (int idx = 1; idx < 16; ++idx)
			{
				shape->Init_Copy (&data, idx, 0);
				shape->Init_Rotate (&data, idx, (idx * 360.0f / 16.0f));
				shape->Init_Finish (&data, idx);
			}
		}
	}
}
