#include "stdafx.h"

#include "Shapes_InitData.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		int CalcSlabRemapTexId (int meshId, int texId, void * data)
		{
			int * src = (int *) data + 0;
			int * dst = (int *) data + (meshId * 6);

			for (int idx = 0; idx < 6; ++idx)
			{
				if (src [idx] == texId)
				{
					return dst [idx];
				}
			}

			assert (false);
			return texId;
		}

		int CalcSlabMeshIdx (int type, int data)
		{
			return data;
		}

		void InitSlab (ShapeBase * shape, int tex [][6], int variantCount)
		{
			InitData data (variantCount, 2 * 6, SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W | SceneSim::FF_OTHER, SceneSim::FF_B);
			
			if (variantCount > 1)
			{
				data.meshIdxFromCellDataFuncPtr = CalcSlabMeshIdx;
			}

			shape->Init (&data, tex [0][0]);
			
			//shape->entCollisions = SceneSim::EC_HALFSTEP;
			shape->gfxBlocking = CellMesh::GB_NONE;
			//shape->gfxBlocking = CellMesh::GB_ALL;

			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, tex [0][SceneSim::F_B]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 0.5f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_N, tex [0][SceneSim::F_N]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 0.5f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_E, tex [0][SceneSim::F_E]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 0.5f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_S, tex [0][SceneSim::F_S]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 0.5f, 1.0f), Vec3 (0.0f, 0.0f, -1.0f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_W, tex [0][SceneSim::F_W]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 0.5f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -1.0f), SceneSim::F_T, tex [0][SceneSim::F_T]);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);

			for (int idx = 1; idx < variantCount; ++idx)
			{
				shape->Init_Copy (&data, idx, 0);
				shape->Init_Retexture (&data, idx, CalcSlabRemapTexId, tex);
				shape->Init_ApplyUvRgbs (&data, idx, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
				shape->Init_Finish (&data, idx);
			}
		}
	}
}
