#include "stdafx.h"

#include "Shapes_InitData.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		int CalcStairMeshIdx (int type, int data)
		{
			switch (data)
			{
			case 0: return 2;
			case 1: return 0;
			case 2: return 3;
			case 3: return 1;
			}
			assert (false);
			return 0;
		}

		void InitStairs (ShapeBase * shape, int tex)
		{
			InitData data (4, 2 * 10, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W | SceneSim::FF_OTHER, SceneSim::FF_B | SceneSim::FF_N);
			data.meshIdxFromCellDataFuncPtr = CalcStairMeshIdx;

			shape->Init (&data, tex);

			//shape->entCollisions = SceneSim::EC_HALFSTEP;
			shape->gfxBlocking = CellMesh::GB_NONE;

			shape->Init_AddQuad (&data, 0, SceneSim::F_T, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -0.5f), SceneSim::F_T, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_N, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 1.0f, 0.5f), Vec3 (0.0f, 0.0f, 0.5f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_E, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 0.5f, 0.0f), Vec3 (0.0f, 0.0f, 0.5f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_E, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 0.5f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -0.5, 0.0f), SceneSim::F_S, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (0.0f, 0.0f, -0.5f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_W, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 0.5f, 0.5f), Vec3 (0.0f, 0.0f, -0.5f), Vec3 (0.0f, -0.5f, 0.0f), SceneSim::F_W, tex);

			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 0.5f, 0.5f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -0.5f), SceneSim::F_T, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, 1.0f, 0.5f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -0.5, 0.0f), SceneSim::F_S, tex);

			shape->Init_Copy (&data, 1, 0);
			shape->Init_Copy (&data, 2, 0);
			shape->Init_Copy (&data, 3, 0);

			shape->Init_Rotate (&data, 1, SceneSim::F_E);
			shape->Init_Rotate (&data, 2, SceneSim::F_S);
			shape->Init_Rotate (&data, 3, SceneSim::F_W);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 1, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 2, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 3, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));

			shape->Init_Finish (&data, 0);
			shape->Init_Finish (&data, 1);
			shape->Init_Finish (&data, 2);
			shape->Init_Finish (&data, 3);
		}
	}
}
