#include "stdafx.h"

#include "Shapes_InitData.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		void InitUnitCube (ShapeBase * shape, int t, int b, int n, int e, int s, int w)
		{
			InitData data (1, 12, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W);

			shape->Init (&data, n);

			shape->Init_AddQuad (&data, 0, SceneSim::F_T, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -1.0f), SceneSim::F_T, t);
			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, b);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_N, n);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 1.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_E, e);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 1.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_S, s);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (0.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_W, w);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);
		}

		void InitUnitCubeTrans (ShapeBase * shape, int t, int b, int n, int e, int s, int w, GFXBLOCKINGS gfxBlocking)
		{
			InitData data (1, 12, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W, 0);

			shape->Init (&data, n);

			shape->gfxBlocking = gfxBlocking;

			shape->Init_AddQuad (&data, 0, SceneSim::F_T, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -1.0f), SceneSim::F_T, t);
			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, b);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_N, n);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 1.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_E, e);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 1.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_S, s);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (0.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_W, w);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);
		}

		void InitUnitCube_CompassRotations (ShapeBase * shape, int t, int b, int n, int e, int s, int w, MeshIdxFromCellDataFuncPtr meshIdxFuncPtr)
		{
			InitData data (4, 12, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W);
			data.meshIdxFromCellDataFuncPtr = meshIdxFuncPtr;

			shape->Init (&data, n);

			shape->Init_AddQuad (&data, 0, SceneSim::F_T, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -1.0f), SceneSim::F_T, t);
			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, b);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_N, n);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 1.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_E, e);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 1.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_S, s);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (0.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_W, w);

			shape->Init_Copy (&data, 1, 0);
			shape->Init_Copy (&data, 2, 0);
			shape->Init_Copy (&data, 3, 0);

			shape->Init_Rotate (&data, 1, SceneSim::F_E);
			shape->Init_Rotate (&data, 2, SceneSim::F_S);
			shape->Init_Rotate (&data, 3, SceneSim::F_W);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 1, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 2, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 3, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));

			shape->Init_Finish (&data, 0);
			shape->Init_Finish (&data, 1);
			shape->Init_Finish (&data, 2);
			shape->Init_Finish (&data, 3);
		}

		int CalcUnitCubeMeshIdx (int type, int data)
		{
			return data;
		}

		int CalcRemapTexId (int meshId, int texId, void * data)
		{
			int * src = (int *) data + 0;
			int * dst = (int *) data + (meshId * 6);

			for (int idx = 0; idx < 6; ++idx)
			{
				if (src [idx] == texId)
				{
					return dst [idx];
				}
			}

			assert (false);
			return texId;
		}

		void InitUnitCube_Textures (ShapeBase * shape, int tex [][6], int variantCount)
		{
			InitData data (variantCount, 2 * 6, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W, SceneSim::FF_T | SceneSim::FF_B | SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_S | SceneSim::FF_W);
			data.meshIdxFromCellDataFuncPtr = CalcUnitCubeMeshIdx;

			shape->Init (&data, tex [0][0]);

			shape->Init_AddQuad (&data, 0, SceneSim::F_T, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -1.0f), SceneSim::F_T, tex [0][SceneSim::F_T]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_B, Vec3 (0.0f, 0.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), SceneSim::F_B, tex [0][SceneSim::F_B]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, 1.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_N, tex [0][SceneSim::F_N]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, 1.0f, 0.0f), Vec3 (0.0f, 0.0f, 1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_E, tex [0][SceneSim::F_E]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_S, Vec3 (0.0f, 1.0f, 0.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_S, tex [0][SceneSim::F_S]);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, 1.0f, 1.0f), Vec3 (0.0f, 0.0f, -1.0f), Vec3 (0.0f, -1.0f, 0.0f), SceneSim::F_W, tex [0][SceneSim::F_W]);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_Finish (&data, 0);

			for (int idx = 1; idx < variantCount; ++idx)
			{
				shape->Init_Copy (&data, idx, 0);
				shape->Init_Retexture (&data, idx, CalcRemapTexId, tex);
				shape->Init_ApplyUvRgbs (&data, idx, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
				shape->Init_Finish (&data, idx);
			}
		}
	}
}
