#include "stdafx.h"

#include "SceneSim/BlockData_Sign.h"
#include "SceneSim/SceneSim_Cell.h"
#include "SceneSim/SceneSim_Column.h"

#include "../Gfx/Gfx_Font.h"
#include "../Gfx/VertexTypes_XyzUvRgb.h"
#include "../SceneGfx/SceneGfx_Column.h"

#include "Shapes_InitData.h"
#include "CellMesh_Defs.h"
#include "CellMesh_ShapeBase.h"

namespace CellMesh
{
	namespace Shapes
	{
		int CalcWallSignMeshIdx (int type, int data)
		{
			//return 0;
			switch (data)
			{
			case 5: return 0;	// n
			case 3: return 1;	// e
			case 4: return 2;	// s
			case 2: return 3;	// w
			}
			assert (false);
			return 0;
		}

		int WallSignAddExtraStuff (AddShapeData * addData, int triIdx)
		{
			//assert (false);
			return 0;

/*
			const int idx = CalcWallSignMeshIdx (addData->cell->type, addData->cell->blockData);

			int triCount = 0;
			float pixel = 0.005f;
			float distFromSign = 2.05f / 16.0f;

			Vec3 origin (0.5f, 0.6f, 1.0f - distFromSign);
			Vec3 cr (0.0f, -0.1f, 0.0f);
			Vec3 dx (pixel, 0.0f, 0.0f);
			Vec3 dy (0.0f, pixel, 0.0f);

			switch (idx)
			{
			case 0: break;
			case 1: origin = Vec3 (1.0f - distFromSign, 0.6f, 0.5f); dx = Vec3 (0.0f, 0.0f, -pixel); break;
			case 2: origin = Vec3 (0.5f, 0.6f, distFromSign); dx = Vec3 (-pixel, 0.0f, 0.0f); break;
			case 3: origin = Vec3 (distFromSign, 0.6f, 0.5f); dx = Vec3 (0.0f, 0.0f, pixel); break;
			}

			Gfx::VertexTypes::XyzUvRgb * verts = &addData->extraVerts [triIdx * 3];

			//Int3 colRel (addData->block->ColRelIdFromBlockRelId(addData->cellXyz));
			Int3 colRel (addData->cellXyz);

			//std::cout << "FIND = " << colRel.x << ", " << colRel.y << ", " << colRel.z << ", " << std::endl;

			SceneSim::BlockData::Sign * sign = addData->column->GetSim ()->BlockData_GetSign (colRel);
			if (sign == NULL)
			{
				return 0;
			}

			// 14 wide
			triCount += addData->font->AddTris (sign->text [0], verts + (triCount * 3), origin, dx, dy);
			origin += cr;

			triCount += addData->font->AddTris (sign->text [1], verts + (triCount * 3), origin, dx, dy);
			origin += cr;

			triCount += addData->font->AddTris (sign->text [2], verts + (triCount * 3), origin, dx, dy);
			origin += cr;

			triCount += addData->font->AddTris (sign->text [3], verts + (triCount * 3), origin, dx, dy);

			return triCount;
*/
		}

		void InitWallSign (ShapeBase * shape, int tex)
		{
			const float unit = 1.0f / 16.0f;

			InitData data (4, 12, SceneSim::FF_N | SceneSim::FF_E | SceneSim::FF_W | SceneSim::FF_OTHER, 0);
			data.meshIdxFromCellDataFuncPtr = CalcWallSignMeshIdx;
			data.newAddExtraStuff = WallSignAddExtraStuff;

			shape->Init (&data, tex);

			//shape->entCollisions = SceneSim::EC_NONE;
			shape->gfxBlocking = CellMesh::GB_NONE;

			shape->Init_AddQuad (&data, 0, SceneSim::F_N, Vec3 (1.0f, unit * 12.0f, 1.0f), Vec3 (-1.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_N, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_E, Vec3 (1.0f, unit * 12.0f, unit * 14.0f), Vec3 (0.0f, 0.0f, unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_E, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_W, Vec3 (0.0f, unit * 12.0f, 1.0f), Vec3 (0.0f, 0.0f, -unit * 2.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_W, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, unit * 12.0f, 1.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, -unit * 2.0f), SceneSim::F_T, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, unit * 4.0f, unit * 14.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, 0.0f, unit * 2.0f), SceneSim::F_B, tex);
			shape->Init_AddQuad (&data, 0, SceneSim::F_OTHER, Vec3 (0.0f, unit * 12.0f, unit * 14.0f), Vec3 (1.0f, 0.0f, 0.0f), Vec3 (0.0f, -unit * 8.0f, 0.0f), SceneSim::F_S, tex);

			shape->Init_Copy (&data, 1, 0);
			shape->Init_Copy (&data, 2, 0);
			shape->Init_Copy (&data, 3, 0);

			shape->Init_Rotate (&data, 1, SceneSim::F_E);
			shape->Init_Rotate (&data, 2, SceneSim::F_S);
			shape->Init_Rotate (&data, 3, SceneSim::F_W);

			shape->Init_ApplyUvRgbs (&data, 0, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 1, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 2, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));
			shape->Init_ApplyUvRgbs (&data, 3, Vec4 (1.0f, 1.0f, 1.0f, 1.0f));

			shape->Init_Finish (&data, 0);
			shape->Init_Finish (&data, 1);
			shape->Init_Finish (&data, 2);
			shape->Init_Finish (&data, 3);
		}
	}
}
