#ifndef _glfonth_
#define _glfonth_

//*********************************************************
//GLFONT.H -- Header for GLFONT.CPP
//Copyright (c) 1998 Brad Fish
//Copyright (c) 2002 Henri Kyrki
//See glFont.txt for terms of use
//10.5 2002
//*********************************************************

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#include <GL/gl.h>

namespace Gfx {namespace VertexTypes {struct XyzUvRgb;}}

namespace GLFontError {
	struct InvalidFile{};
	struct InvalidFont{};
}

class GLFontBase {
public:
	GLFontBase();
	void Begin();
	virtual ~GLFontBase();
protected:

	void CreateImpl(const char * FileName, GLuint Tex, bool PixelPerfect = FALSE);

	typedef struct
	{
	union {
		float dx;
		int width;
	};
	union {
		float dy;
		int height;
	};
	float tx1, ty1;
	float tx2, ty2;
	} GLFONTCHAR;

	typedef struct
	{
	int Tex;
	int TexWidth, TexHeight;
	int IntStart, IntEnd;
	GLFONTCHAR *Char;
	} GLFONT;

	GLFONT Font;
	bool ok;
private:
	void FreeResources();
};

class GLFont : public GLFontBase {
public:
	GLFont();
	void Create(const char * FileName, GLuint Tex);
	int TextLength (const char * String);
	int TextOut (const char * String, float x, float y, float z);
	int AddTris (const char * text, Gfx::VertexTypes::XyzUvRgb * verts, Vec3 origin, Vec3 dx, Vec3 dy) const;
};

class PixelPerfectGLFont : public GLFontBase {
public:
	PixelPerfectGLFont();
	void Create(const char * FileName, GLuint Tex);
	int CharLength (char c);
	int TextLength (const char * String);
	int TextOut (const char * String, int x, int y, int z);
	int TextOut (const char * String, int charStart, int charEnd, int x, int y, int z);
	int AddTris (const char * text, Gfx::VertexTypes::XyzUvRgb * verts, Vec3 origin, Vec3 dx, Vec3 dy) const;
};

#endif
//End of file


