#include "stdafx.h"

#include "Gfx_Camera.h"
#include "Gfx_Viewport.h"

namespace Gfx
{
	Camera::Camera (const Viewport * viewport)
		: xyz (0.0f, 0.0f, 0.0f),
		ypr (0.0f, 0.0f, 0.0f),
		clipNear (0.1f),
		//clipNear (30.0f),
        clipFar (10000.0f)
	{
		//CalcProjectionMatrix (viewport->w, viewport->h);
	}

	void Camera::Apply ()
    {
		CalcProjectionMatrix (1024, 600);
		CalcViewMatrix (1024, 600);

		glMatrixMode (GL_PROJECTION);
		glLoadMatrixf ((GLfloat *) &matProjection);

		glMatrixMode (GL_MODELVIEW);
		glLoadMatrixf ((GLfloat *) &matView);
    }

	void Camera::CalcProjectionMatrix (int w, int h)
	{
		matProjection = glm::perspectiveFov (80.0f, (float) w, (float) h, clipNear, clipFar);
	}

	void Camera::CalcViewMatrix (int w, int h)
    {
		matView = Mat44 ();
		matView = glm::rotate (matView, ypr.x, Vec3 (1.0f, 0.0f, 0.0f));
		matView = glm::rotate (matView, ypr.y, Vec3 (0.0f, 1.0f, 0.0f));
		matView = glm::translate (matView, Vec3 (-xyz.x, -xyz.y, -xyz.z));
    }
}
