#pragma once

class GLFont;
class PixelPerfectGLFont;

namespace Gfx {namespace VertexTypes {struct XyzUvRgb;}}

namespace Gfx
{
	class Font
	{
	public:
		Font (const char * filename);
		~Font ();

		int GetLength (char c);
		int GetLength (const char * text);
		int DoMaxLengthTestReverse (const char * text, int maxLength, int * outStartAtCharIdx);

		void Begin ();
		int DrawString (const char * text, int x, int y);
		int DrawString (const char * text, int x, int y, int z);
		int DrawString (const char * text, int charStart, int charEnd, int x, int y);
		void End ();

		int AddTris (const char * text, Gfx::VertexTypes::XyzUvRgb * verts, Vec3 origin, Vec3 dx, Vec3 dy) const;

	private:
		GLuint texture;				// This is a handle to our texture object
		PixelPerfectGLFont * font;

		bool hasBegun;
	};
}