#include "stdafx.h"

#include "Gfx_Funcs.h"

namespace Gfx
{
	PFNGLGENBUFFERSARBPROC glGenBuffersARB = NULL;
	PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB = NULL;

	PFNGLBINDBUFFERARBPROC glBindBufferARB = NULL;
	PFNGLBUFFERDATAARBPROC glBufferDataARB = NULL;
	PFNGLBUFFERSUBDATAARBPROC glBufferSubDataARB = NULL;

	//PFNGLGENERATEMIPMAPEXTPROC glGenerateMipmapARB = NULL;

	PFNGLPOINTPARAMETERFARBPROC glPointParameterfARB = NULL;
	PFNGLPOINTPARAMETERFVARBPROC glPointParameterfvARB = NULL;

	void LoadOpenGlFunctions ()
	{
		glGenBuffersARB = (PFNGLGENBUFFERSARBPROC) wglGetProcAddress ("glGenBuffersARB");
		glDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC) wglGetProcAddress ("glDeleteBuffersARB");

		glBindBufferARB = (PFNGLBINDBUFFERARBPROC) wglGetProcAddress ("glBindBufferARB");
		glBufferDataARB = (PFNGLBUFFERDATAARBPROC) wglGetProcAddress ("glBufferDataARB");
		glBufferSubDataARB = (PFNGLBUFFERSUBDATAARBPROC) wglGetProcAddress ("glBufferSubDataARB");

		//glGenerateMipmapARB = (PFNGLGENERATEMIPMAPEXTPROC) wglGetProcAddress ("glGenerateMipmapARB");

		glPointParameterfARB = (PFNGLPOINTPARAMETERFARBPROC) wglGetProcAddress ("glPointParameterfARB");
		glPointParameterfvARB = (PFNGLPOINTPARAMETERFVARBPROC) wglGetProcAddress ("glPointParameterfvARB");
	}

	int CalcSize_xyzRgb (int primType, int primCount)
	{
		assert (primType == GL_QUADS);

		int s = 0;
		s += sizeof (GLfloat) * primCount * 3 * 4; // xyz
		s += sizeof (GLfloat) * primCount * 3 * 4; // rgb

		return s;
	}
}