#pragma once

#include "SDL/SDL-1.2.14 sdk/include/SDL_opengl.h" 

namespace Gfx
{
	class GfxTex
	{
	public:

		GfxTex (TextRef filename);
		~GfxTex ();

		Int2 GetWh () const;

		void UploadToGfxCard ();

		void Bind ();
		void Unbind ();

		void UpdateRegion (unsigned * pixels, int x, int y, int w, int h);

	private:

		GLuint texture;				// This is a handle to our texture object
		GLenum texture_format;
		GLint  nOfColors;

		bool LoadTexture (TextRef filename);

		Int2 wh;
		GLubyte * rawData;
	};
}
