#pragma once

namespace SceneGfx {class Column;}
namespace SceneGfx {class World;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}
namespace Thread {class JobMngr;}

namespace GfxFactory
{
	class GfxFactory
	{
	public:

		GfxFactory (SceneSim::World * simWorld, SceneGfx::World * gfxWorld);
		~GfxFactory ();

		int GetJobCount () const;

		void Update ();

		void RequestGfxColumnMeshRefresh (Int3 columnId);

		void OnSimWorldAdded (SceneSim::World * simWorld);
		void OnSimRoomAdded (SceneSim::Room * room);
		void OnSimColumnAdded (SceneSim::Column * column);

		Thread::JobMngr * jobMngr;
		SceneSim::World * simWorld;
		SceneGfx::World * gfxWorld;
	};
}
