#pragma once

#include "Thread/Thread_Job.h"

#include "SceneCollections/SceneCollections_LocalColumns.h"

namespace CsgEffect {class CsgEffectBase;}
namespace GfxFactory {class GfxFactory;}
namespace SceneChange {class CreateBlockMeshes;}

namespace GfxFactory
{
	class JobApplyCsgGfx : public Thread::Job
	{
	public:

		JobApplyCsgGfx (GfxFactory * gfxFactory, RakNet::Time * applied, TextRef roomId, SceneCollections::LocalColumns * columns, SceneCollections::LocalColumns * columnsEdge);
		virtual ~JobApplyCsgGfx ();

	protected:

		virtual Thread::JOBSTATES JobDoWork ();
		virtual Thread::JOBSTATES JobOnCompleted ();

	private:

		GfxFactory * gfxFactory;
		RakNet::Time applied;
		Text roomId;

		SceneCollections::LocalColumns columns;
		SceneCollections::LocalColumns columnsEdge;

		int changedColumnsCount;
		SceneChange::CreateBlockMeshes * * blockCreaters;
	};
}
