#pragma once

#include "Thread/Thread_Job.h"

namespace SceneCollections {class LocalColumns;}

namespace GfxFactory
{
	class JobApplyCsgSim : public Thread::Job
	{
	public:

		JobApplyCsgSim (GfxFactory * gfxFactory);
		virtual ~JobApplyCsgSim ();

		RakNet::Time applied;
		Text roomId;
		Int3 columnId;
		Int3 cellId;
		float radius;
		int cellType;
		int cellData;

	protected:

		virtual Thread::JOBSTATES JobDoWork ();
		virtual Thread::JOBSTATES JobOnCompleted ();

	private:

		void AddEdgeIfEmpty (Int3 columnId);

		GfxFactory * gfxFactory;

		SceneCollections::LocalColumns * columnsDirty;
		SceneCollections::LocalColumns * columnsEdge;
	};
}
