#include "stdafx.h"

#include "../Gfx/Gfx_Font.h"

#include "Debug_GfxStream.h"

namespace Debug
{
	DebugStream_Gfx::DebugStream_Gfx (Gfx::Font * font, int stringsMax, int x, int y)
		: font (font),
		stringsMax (stringsMax),
		stringsIdx (0),
		strings (NULL),
		startX (x),
		startY (y)
	{
		strings = aah_new char [stringsMax * stringsLength];
		memset (strings, 0, stringsMax * stringsLength);
	}

	DebugStream_Gfx::~DebugStream_Gfx ()
	{
		delete [] strings;
		strings = NULL;
	}

	void DebugStream_Gfx::WriteLine (const char * str)
	{
		if (stringsIdx == stringsMax)
		{
			for (int copyIdx = 0; copyIdx < stringsMax - 1; ++copyIdx)
			{
				memcpy (&strings [copyIdx * stringsLength], &strings [(copyIdx + 1) * stringsLength], stringsLength);
			}

			--stringsIdx;
		}

		strncpy (&strings [stringsIdx * stringsLength], str, stringsLength - 1);
		++stringsIdx;
	}

	void DebugStream_Gfx::Flush ()
	{
		int x = startX;
		int y = startY;
		int lineHeight = 20;

		// render brief messages
		for (int idx = 0; idx < stringsIdx; ++idx)
		{
			font->DrawString (&strings [idx * stringsLength], x, y); 
			y += lineHeight;
		}
	}

	void DebugStream_Gfx::Clear ()
	{
		stringsIdx = 0;
	}
}
