#include "stdafx.h"

#include "Profile/Profile_Record.h"
#include "Profile/Profile_ProfileScope.h"

#include "Plot_Profiler.h"

namespace Plot
{
	void Plot_Profiler (Int2 viewportSize)
	{
		// begin
		glEnable (GL_BLEND);
		glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glDisable (GL_DEPTH_TEST);
		glDisable (GL_TEXTURE_2D);
		glDisable (GL_CULL_FACE); 
		glDisable (GL_ALPHA_TEST);
		
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity( );
		
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glOrtho(0.0f, (GLsizei) viewportSize.x, (GLsizei) viewportSize.y, 0.0f, 0.0f, 1.0f);

		glBegin (GL_LINES);

		// render in here

		Int2 tl (50, 50);
		Int2 size (200, 500);

		int idx = 0;
		while (true)
		{
			Profile::ProfileThread * thread = Profile::ProfileApp::GetThreadByIdx (idx);
			if (thread == NULL)
			{
				break;
			}
			++idx;

			int recordId = 0;
			while (true)
			{
				Profile::Record * record = thread->GetRecord (recordId);
				if (record == NULL)
				{
					break;
				}
				++recordId;
					
				Int2 current = tl;
				int historyIdx = (thread->historyIdx + Profile::Record::historyLength - 500) % Profile::Record::historyLength;
				int oldY = (int) (record->history [historyIdx] * 10000.0f);

				historyIdx = (historyIdx + 1) % Profile::Record::historyLength;
				for (; historyIdx != thread->historyIdx; historyIdx = (historyIdx + 1) % Profile::Record::historyLength)
				{
					glColor4ub (record->r, record->g, record->b, 255);
					glVertex2i (current.x, current.y + size.y - oldY);

					current.x += 2;
					oldY = (int) (record->history [historyIdx] * 10000.0f);

					glColor4ub (record->r, record->g, record->b, 255);
					glVertex2i (current.x, current.y + size.y - oldY);
				}
			}
		}

		// end
		glEnd ();

		glEnable (GL_DEPTH_TEST);
		glEnable (GL_TEXTURE_2D);
		glEnable (GL_CULL_FACE); 
		glEnable (GL_ALPHA_TEST);
	}
}