#pragma once

#include "SceneGfx_Defs.h"

namespace CellBuilder {class Mngr;}
namespace CellMesh {class Mngr;}
namespace Gfx {namespace Buffers {class TriList;}}
namespace Gfx {namespace VertexTypes {struct XyzUvRgb;}}
namespace SceneGfx {class Column;}
namespace SceneFile {class Command_BlockRecreate;}
namespace SceneSim {class Column;}

namespace SceneGfx
{
	class Block
	{
	public:

		Block (Vec3 rgb); // just create a cube
		//Block (Column * column, int blockId); // retired by next function
		Block (int blockId, const SceneSim::AdjColumns * columns, const CellMesh::Mngr * meshMngr, const CellBuilder::Mngr * builderMngr);
		~Block ();

		void CopyToGfxCardIfNeeded ();

		void Render (int passIdx);

		const Int3 columnId;
		const int blockId;

	private:

		bool copyToGfxCardIfNeeded;

		Gfx::VertexTypes::XyzUvRgb * verts;
		Gfx::Buffers::TriList * buffer;
		int vertsTotal;

		Gfx::VertexTypes::XyzUvRgb * extraVerts;
		Gfx::Buffers::TriList * bufferExtra;
		int extraVertsTotal;
	};
}