#pragma once

#include "SceneGfx_Defs.h"

namespace SceneGfx {class Block;}
namespace SceneGfx {class Room;}
namespace SceneSim {class Column;}
namespace Thread {class Job;}
namespace Thread {class JobMngr;}

namespace SceneGfx
{
	extern void Column_DrawDebug ();

	class Column
	{
	public:

		Column (Room * room, SceneSim::Column * column);
		~Column ();

		Room * GetRoom () const;
		SceneSim::Column * GetSim () const;

		void Update ();
		void Render (int passIdx, Int3 columnId, Vec3 colRelPos, int drawDistance, Int3 offset);

		void AddOrReplaceBlock (Block * block);

		void SwapWith (Column * other);

		//void MarkDirty ();
		//void MarkDirty (Int3 colRelPos, bool touchNeighbours);
		//bool IsDirty (int blockId) const;

	private:

		//static int CreateBlockStatic (Thread::Job * job);

		Room * const room;
		SceneSim::Column * sim;

		int cellsSolids [BlocksPerColY];
		Block * blocks [BlocksPerColY];
		//bool isBlockDirty [BlocksPerColY];

		//Thread::Job * job;
	};
}
