#pragma once

#include "Thread/Thread_Job.h"
#include "Thread/Thread_SafeList.h"

namespace SceneGfx {class Block;}
namespace SceneGfx {class Column;}

namespace SceneGfx
{
	class JobCreateBlockMesh : public Thread::Job
	{
	public:

		JobCreateBlockMesh (
			Thread::JobMngr * jobMngr, 
			Column * column,
			int blockId,
			Thread::SafeList <JobCreateBlockMesh *> * list);
		
		virtual Thread::JOBSTATES JobDoWork ();
		virtual Thread::JOBSTATES JobOnCompleted ();

		// inputs
		const int blockId;

	private:

		// inputs
		Column * column;
		Thread::SafeList <JobCreateBlockMesh *> * list;

		// outputs
		SceneGfx::Block * block;
	};
}
