#pragma once

#include "Thread/Thread_Job.h"

namespace SceneGfx {class Block;}
namespace SceneGfx {class BlockChangeList;}
namespace SceneGfx {class Column;}
namespace SceneGfx {class Room;}
namespace SceneSim {class Column;}

namespace SceneGfx
{
	class JobCreateBlockMeshes : public Thread::Job
	{
	public:

		JobCreateBlockMeshes (Thread::JobMngr * jobMngr, SceneGfx::Room * room, SceneGfx::BlockChangeList * changes);

		virtual ~JobCreateBlockMeshes ();
		
		virtual Thread::JOBSTATES JobDoWork ();
		virtual Thread::JOBSTATES JobOnCompleted ();

	private:

		// inputs
		SceneGfx::Room * room;
		SceneGfx::BlockChangeList * changes;
		int blockChangesCount;

		// working data
		SceneSim::Column * * columnSrcs;

		// outputs
		SceneGfx::Block * * blocks;
	};
}
