#include "stdafx.h"

//#include "../Gfx/Gfx_Font.h"

#include "CellBuilder_Mngr.h"
#include "CellBuilder_ShapeBase.h"
#include "CellBuilder_ShapeDefaults.h"
#include "CellBuilder_ShapeInitData.h"

namespace CellBuilder
{
	Mngr::Mngr ()
		: shapeTotal (256)
	{
		shapes = aah_new ShapeBase [shapeTotal];

		// init to solid

		for (int idx = 0; idx < shapeTotal; ++idx)
		{
			shapes [idx].Set (SceneSim::EC_UNITCUBE, true);
		}

		shapes [0].Set (SceneSim::EC_NONE, false); // air

		shapes [5].Set (SceneSim::EC_UNITCUBE, false);
		shapes [6].Set (SceneSim::EC_UNITCUBE, false);
		shapes [8].Set (SceneSim::EC_NONE, false);
		shapes [15].Set (SceneSim::EC_UNITCUBE, false);
		shapes [15].Set (SceneSim::EC_UNITCUBE, false);
		shapes [23].Set (SceneSim::EC_UNITCUBE, false);
		shapes [28].Set (SceneSim::EC_UNITCUBE, false);
		shapes [29].Set (SceneSim::EC_UNITCUBE, false);
		shapes [30].Set (SceneSim::EC_NONE, false);
		shapes [39].Set (SceneSim::EC_UNITCUBE, false);
		shapes [41].Set (SceneSim::EC_NONE, false);
		shapes [44].Set (SceneSim::EC_NONE, false);
		shapes [45].Set (SceneSim::EC_NONE, false);
		shapes [51].Set (SceneSim::EC_UNITCUBE, false);
		shapes [57].Set (SceneSim::EC_UNITCUBE, false);
		shapes [58].Set (SceneSim::EC_UNITCUBE, false);



		//shapes [6].Set (SceneSim::EC_NONE, false); // sapling
		//shapes [8].Set (SceneSim::EC_UNITCUBE, true); // water
		//shapes [9].Set (SceneSim::EC_HALFSTEP, true); // stationary water
		//shapes [11].Set (SceneSim::EC_HALFSTEP, true); // stationary lava
		//shapes [20].Set (SceneSim::EC_UNITCUBE, false); // fence
		//shapes [27].Set (SceneSim::EC_NONE, false); // powered rail
		//shapes [28].Set (SceneSim::EC_NONE, false); // detector rail
		////shapes [29].Set (SceneSim::EC_NONE, false); // sticky piston base
		////shapes [33].Set (SceneSim::EC_NONE, false); // normal piston base
		//shapes [31].Set (SceneSim::EC_NONE, false); // tall grass
		//shapes [32].Set (SceneSim::EC_NONE, false); // dead bush
		//shapes [37].Set (SceneSim::EC_NONE, false); // dandelion
		//shapes [38].Set (SceneSim::EC_NONE, false); // rose
		//shapes [39].Set (SceneSim::EC_NONE, false); // brown mushroom
		//shapes [40].Set (SceneSim::EC_NONE, false); // red mushroom
		//shapes [44].Set (SceneSim::EC_HALFSTEP, true); // slab
		//shapes [50].Set (SceneSim::EC_NONE, false); // torch
		//shapes [51].Set (SceneSim::EC_NONE, false); // fire
		//shapes [53].Set (SceneSim::EC_STAIR, true); // wooden stairs
		//shapes [55].Set (SceneSim::EC_NONE, false); // redstone wire
		//shapes [59].Set (SceneSim::EC_NONE, false); // seeds
		//shapes [63].Set (SceneSim::EC_NONE, false); // sign post
		//shapes [64].Set (SceneSim::EC_NONE, false); // wooden door
		//shapes [65].Set (SceneSim::EC_NONE, false); // ladder
		//shapes [66].Set (SceneSim::EC_NONE, false); // railway
		//shapes [67].Set (SceneSim::EC_STAIR, true); // cobblestone stairs
		//shapes [68].Set (SceneSim::EC_NONE, false); // wall sign
		//shapes [69].Set (SceneSim::EC_NONE, false); // stone button
		//shapes [70].Set (SceneSim::EC_NONE, false); // wooden pressure plate
		//shapes [71].Set (SceneSim::EC_NONE, false); // iron door
		//shapes [72].Set (SceneSim::EC_NONE, false); // stone pressure plate
		//shapes [75].Set (SceneSim::EC_NONE, false); // redstone torch (off)
		//shapes [76].Set (SceneSim::EC_NONE, false); // redstone torch (on)
		//shapes [77].Set (SceneSim::EC_NONE, false); // stone button
		//shapes [78].Set (SceneSim::EC_NONE, true); // snow
		//shapes [81].Set (SceneSim::EC_UNITCUBE, false); // cactus
		//shapes [83].Set (SceneSim::EC_NONE, false); // sugar cane
		//shapes [85].Set (SceneSim::EC_FENCEPOST, false); // fence
		//shapes [92].Set (SceneSim::EC_HALFSTEP, false); // cake
		//shapes [96].Set (SceneSim::EC_HALFSTEP, false); // hatch
		//shapes [104].Set (SceneSim::EC_NONE, true); // pumpkin stem
		//shapes [105].Set (SceneSim::EC_NONE, true); // melon stem
		//shapes [107].Set (SceneSim::EC_NONE, false); // gate
		//shapes [108].Set (SceneSim::EC_STAIR, true); // brick stairs
		//shapes [109].Set (SceneSim::EC_STAIR, true); // stone brick stairs
		//shapes [111].Set (SceneSim::EC_NONE, false); // lily


		//// new blocks

		//shapes [129].Set (SceneSim::EC_STAIR, false); // wood slope
		//shapes [130].Set (SceneSim::EC_STAIR, false); // cobblestone slope
	}

	Mngr::~Mngr ()
	{
		delete [] shapes;
	}

	const ShapeBase * Mngr::GetShape (int shapeId) const
	{
		if (shapeId >= shapeTotal || shapeId < 0)
		{
			assert (false);
			return NULL;
		}

		return &shapes [shapeId];
	}
}