#include "stdafx.h"

#include "Collision_BoxSwept_Box.h"
#include "Collision_Result.h"

namespace Collision
{
    float GetOverlapTime (float v1, float v2, float v3, float v4, float d)
    {
        // already overlapping
        if (v2 > v3 && v1 < v4)
        {
            return 0.0f;
        }
        // may overlap when moving right
        else if (d > 0.0f && v2 <= v3)
        {
            return (v3 - v2) / d;
        }
        // may overlap when moving left
        else if (d < 0.0f && v1 >= v3)
        {
            return (v4 - v1) / d;
        }
        return 10000000.0f;
    }

	bool BoxSwept_Box (Vec3 bl1, Vec3 tr1, Vec3 delta, Vec3 bl2, Vec3 tr2, Result * result)
	{
        float collX = GetOverlapTime (bl1.x, tr1.x, bl2.x, tr2.x, delta.x);
        float collY = GetOverlapTime (bl1.y, tr1.y, bl2.y, tr2.y, delta.y);
        float collZ = GetOverlapTime (bl1.z, tr1.z, bl2.z, tr2.z, delta.z);

        // final solution
        if (collX <= 1.0f && collY <= 1.0f && collZ <= 1.0f)
        {
			float coll = collX;
			SceneSim::FACES entryFace = (delta.x > 0.0f) ? SceneSim::F_W : SceneSim::F_E;
			if (collY > coll)
			{
				coll = collY;
				entryFace = (delta.y > 0.0f) ? SceneSim::F_B : SceneSim::F_T;
			}
			if (collZ > coll)
			{
				coll = collZ;
				entryFace = (delta.z > 0.0f) ? SceneSim::F_S : SceneSim::F_N;
			}

			if (result != NULL)
			{
				if (result->resultType == RT_NONE || coll < result->entryTime)
				{
					result->resultType = RT_COLLISION;
					result->resultFlags = RF_ENTRYTIME | RF_ENTRYFACE;
					result->entryTime = coll;
					result->entryFace = entryFace;
				}
			}
			return true;
        }

        return false;
	}
}