#include "stdafx.h"

#include "../Gfx/Gfx_Camera.h"
#include "../Gfx/Gfx_Viewport.h"

#include "Collision_Pick.h"

namespace Collision
{
	void Pick_RayFromCamera (const Gfx::Viewport * viewport, int x, int y, const Gfx::Camera * camera, Vec3 * rayPos, Vec3 * rayDir)
	{
		*rayPos = glm::unProject (
			Vec3 (x, y, 0.0f),
			camera->matView,
			camera->matProjection,
			//Vec4 (viewport->w, viewport->h, 0.0f, 1.0f));
			Vec4 (0.0f, 0.0f, viewport->size.x, viewport->size.y));

		*rayDir = glm::unProject (
			Vec3 (x, y, 1.0f),
			camera->matView,
			camera->matProjection,
			Vec4 (0.0f, 0.0f, viewport->size.x, viewport->size.y));

		*rayDir -= *rayPos;

		*rayDir = glm::normalize (*rayDir);
	}
}