#pragma once

#include "../Ents/Comps_Coord.h"
#include "../SceneSim/SceneSim_Defs.h"

//namespace SceneSim {class Block;}
//namespace SceneSim {class Column;}

namespace Collision
{
	enum RESULTTYPES
	{
		RT_NONE,
		RT_COLLISION,
		RT_BOUNDARYCOLLISION,
	};

	enum RESULTFLAGS
	{
		RF_ENTRYPOS		= 1 << 0,
		RF_ENTRYCOLUMN	= 1 << 1,
		RF_ENTRYTIME	= 1 << 2,
		RF_ENTRYDISTSQR	= 1 << 3,
		RF_ENTRYCELL	= 1 << 4,
		RF_ENTRYFACE	= 1 << 5,

		RF_EXITPOS		= 1 << 6,
		RF_EXITCOLUMN	= 1 << 7,
		RF_EXITTIME		= 1 << 8,
		RF_EXITDISTSQR	= 1 << 9,
		RF_EXITFACE	= 1 << 10,
	};

	class Result
	{
	public:

		Result ();

		void Clear ();

		RESULTTYPES resultType;
		unsigned int resultFlags;

		Ents::Comps::Coord entryPos;
		float entryTime;
		float entryDistanceSqr;
		Int3 entryCell;
		SceneSim::FACES entryFace;

		Ents::Comps::Coord exitPos;
		float exitTime;
		float exitDistanceSqr;
		SceneSim::FACES exitFace;
	};
}
