#include "stdafx.h"

#include "CsgEffect_ColumnChanges.h"

namespace CsgEffect
{
	ColumnChanges::ColumnChanges (int newCellType, int newCellData)
		: newCellType (newCellType),
		newCellData (newCellData)
	{
		Clear ();
	}
	
	void ColumnChanges::Clear ()
	{
		memset (stripsTouched, 0, sizeof (stripsTouched));
		memset (edgesTouched, 0, sizeof (edgesTouched));
	}

	void ColumnChanges::CalcEdgesTouched ()
	{
		edgesTouched [SceneSim::F_N] = (stripsTouched [SceneSim::CellsPerColXz - 1] != 0);
		edgesTouched [SceneSim::F_S] = (stripsTouched [0] != 0);

		unsigned short test = 0;
		for (int z = 0; z < 16; ++z)
		{
			test |= stripsTouched [z];
		}
		
		edgesTouched [SceneSim::F_E] = (test & (1 << SceneSim::CellsPerColXz - 1)) != 0;
		edgesTouched [SceneSim::F_W] = (test & (1 << 0)) != 0;
	}
}
