#pragma once

#include "CsgEffect_CsgEffectBase.h"

namespace CsgEffect
{
	class Sphere : public CsgEffectBase
	{
	public:
		
		Sphere (Int3 columnId, Int3 cellId, float radius);
		virtual ~Sphere ();

		virtual int GetColumnAffectedCount () const;
		virtual Int3 GetColumnIdAffected (int nth) const;

		virtual void ApplyChanges (int nth, SceneSim::Column * column, const CellBuilder::Mngr * cellBuilder, ColumnChanges * changes);

	private:

		Int3 columnId;
		Int3 cellId;
		float radius;

		static const int affectColumnRadiusMax = 2;
		static const int affectColumnCountMax = (affectColumnRadiusMax * 2 + 1) * (affectColumnRadiusMax * 2 + 1);

		int affectedColumnCount;
		Int3 affectedColumnIds [affectColumnCountMax];
	};
}
