#pragma once

namespace SceneSim {class Room;}
namespace SceneSim {class Column;}

namespace Ents
{
	namespace Comps
	{
		class Coord
		{
		public:

			Coord ();
			Coord (Int3 columnId, Vec3 colRelPos);
			Coord (const Coord & other);
			~Coord ();

			void Fix ();

			Int3 GetColumnId () const;
			Vec3 GetColumnRelPos () const;
			Vec3 GetColumnRelPos (Int3 other) const;

			void SetColumnId (Int3 columnId);
			void SetColRelPos (Vec3 colRelPos);

			// these move the coord and track changes in column
			bool MoveTo (Int3 columnId, Vec3 colRelPos);
			bool MoveTo (Vec3 colRelPos);
			bool MoveBy (Vec3 delta);

			Coord & operator + (const Vec3 & xyz);
			Coord & operator += (const Vec3 & xyz);
			Coord & operator - (const Vec3 & xyz);
			Coord & operator -= (const Vec3 & xyz);
			Coord & operator = (const Coord & rhs);

			Vec3 DeltaTo (const Coord * to) const;
			float DistSqr (const Coord * to) const;

		protected:

			Int3 columnId;
			Vec3 colRelPos;
		};
	}
}
