#pragma once

namespace Ents {namespace Comps {class Coord;}}
namespace Ents {namespace Comps {class Orient;}}
namespace Ld {class ColumnMask;}
namespace SceneSim {class Room;}

namespace Ents
{
	namespace Comps
	{
		enum MOTION_DIRECTIONS
		{
			MD_X = 1 << 0,
			MD_Y = 1 << 1,
			MD_Z = 1 << 2,
		};

		enum MOTION_RESULTS
		{
			MR_BLOCKEDX = 1 << 0,
			MR_BLOCKEDY = 1 << 1,
			MR_BLOCKEDZ = 1 << 2,
		};

		class Motion
		{
		public:

			Motion (Coord * coord);
			Motion (Coord * coord, Orient * orient);
			~Motion ();

			Vec3 GetVelocity () const;
			void SetVelocity (Vec3 velocity);

			void SetSize (Vec3 size);
			Vec3 GetSize () const; 

			int AttemptMotion (float delta, SceneSim::Room * room, int directions); // returns MOTION_RESULTS flags if blocked in that direction, otherwise 0 for no collision
			int AttemptMotionWithClimbing (float delta, SceneSim::Room * room, int directions, float maxClimbHeight, Ld::ColumnMask * mask); // returns MOTION_RESULTS flags if blocked in that direction, otherwise 0 for no collision
			Vec3 GetAttemptMotionIntersectTimes () const;

		protected:

			float AttemptSimpleMotion (SceneSim::Room * room, Vec3 vel, Ld::ColumnMask * mask) const;

			Coord * const coord;
			Orient * const orient;

			Vec3 velocity;
			Vec3 size;
			Vec3 intersectionTimes;
		};
	}
}
