#pragma once

namespace Collision {class Result;}
namespace Ents {namespace Comps {class Coord;}}
namespace Ents {namespace Comps {class Orient;}}
namespace Ld {class ColumnMask;}
namespace SceneSim {class Room;}

namespace Ents
{
	namespace Comps
	{
		class MotionRay
		{
		public:

			MotionRay (Coord * coord);
			MotionRay (Coord * coord, Orient * orient);
			~MotionRay ();

			Vec3 GetVelocity () const;
			void SetVelocity (Vec3 velocity);

			bool AttemptMotion (float timeStep, SceneSim::Room * room, Ld::ColumnMask * mask); // returns true if collided during motion
			const Collision::Result * GetMotionResult () const;

		protected:

			Coord * const coord;
			Orient * const orient;

			Vec3 velocity;
			Collision::Result * result;
		};
	}
}
