#pragma once

namespace Gfx {class Camera;}
namespace Ents {namespace Comps {class Coord;}}

namespace Ents
{
	namespace Comps
	{
		class Orient
		{
		public:

			Orient (Coord * coord, Vec3 ypr);
			~Orient ();

			void TurnYawBy (float yawBy);
			void TurnPitchBy (float pitchBy);
			void ClampPitch ();

			void SetYpr (Vec3 ypr);
			Vec3 GetYpr () const;
			
			void GetYawMat (Mat44 * result) const;
			void GetYprMat (Mat44 * result) const;

			void SetCamera (Gfx::Camera * camera, Vec3 offset) const;

		protected:

			Coord * const coord;
			Vec3 ypr;
		};
	}
}
