#include "stdafx.h"

#include "../Collision/Collision_Box_Cell.h"

#include "Ents_CMO_Box.h"

namespace Ents
{
	CMO_Box::CMO_Box ()
		: Base (GetNextId ()),
		motion (&coord),
		orient (&coord, Vec3 (0.0f, 0.0f, 0.0f)),
		motionResult (0)
	{
	}

	CMO_Box::CMO_Box (int id)
		: Base (id),
		motion (&coord),
		orient (&coord, Vec3 (0.0f, 0.0f, 0.0f)),
		motionResult (0)
	{
	}

	CMO_Box::~CMO_Box ()
	{
	}

	void CMO_Box::Update (float timeStep, SceneSim::Room * room, bool canClimb, Ld::ColumnMask * mask)
	{
		assert (room != NULL);

		if (canClimb)
		{
			motionResult = motion.AttemptMotionWithClimbing (timeStep, room, Comps::MD_X | Comps::MD_Y | Comps::MD_Z, 0.1f, mask);
		}
		else
		{
			motionResult = motion.AttemptMotion (timeStep, room, Comps::MD_X | Comps::MD_Y | Comps::MD_Z);
		}
	}

	bool CMO_Box::IsOverlapping (SceneSim::Room * room, Int3 columnId, Int3 cellId) const
	{
		Vec3 bl = coord.GetColumnRelPos ();
		Vec3 tr = bl + motion.GetSize ();
		return Collision::Box_Cell (coord.GetColumnId (), bl, tr, room, columnId, cellId);
	}
}

