#include "stdafx.h"

#include "Gfx_Camera.h"
#include "Gfx_Viewport.h"

namespace Gfx
{
	Camera::Camera (const Viewport * viewport)
		: xyz (0.0f, 0.0f, 0.0f),
		ypr (0.0f, 0.0f, 0.0f),
		clipNear (0.075f),
        clipFar (500.0f),
		viewportSize (viewport->size)
	{
	}

	void Camera::Apply ()
    {
		CalcProjectionMatrix ();
		CalcViewMatrix ();
    }

	void Camera::CalcProjectionMatrix ()
	{
		matProjection = glm::perspectiveFov (80.0f, (float) viewportSize.x, (float) viewportSize.y, clipNear, clipFar);
	}

	void Camera::CalcViewMatrix ()
    {
		matView = Mat44 ();
		matView = glm::rotate (matView, ypr.x, Vec3 (1.0f, 0.0f, 0.0f));
		matView = glm::rotate (matView, ypr.y, Vec3 (0.0f, 1.0f, 0.0f));
		matView = glm::translate (matView, Vec3 (-xyz.x, -xyz.y, -xyz.z));
    }
}
