#include "stdafx.h"

#include "../Gfx/Gfx_Camera.h"
#include "../Gfx/Gfx_Viewport.h"

#include "Input_InputMngr.h"
#include "Input_Keys.h"
#include "Input_Mouse.h"

namespace Input
{
	InputMngr::InputMngr (Int2 size)
		: viewport (viewport)
	{
		keys = aah_new Keys ();
		mouse = aah_new Mouse ();
		viewport = aah_new Gfx::Viewport (size);
		camera = aah_new Gfx::Camera (viewport);
	}

	InputMngr::~InputMngr ()
	{
		delete keys;
		delete mouse;
		delete viewport;
		delete camera;
	}

	void InputMngr::Update ()
	{
		mouse->Update ();
		keys->Update ();
	}

	Keys * InputMngr::GetKeys ()
	{
		return keys;
	}

	Mouse * InputMngr::GetMouse ()
	{
		return mouse;
	}

	Gfx::Viewport * InputMngr::GetViewport ()
	{
		return viewport;
	}

	const Gfx::Viewport * InputMngr::GetViewport () const
	{
		return viewport;
	}

	Gfx::Camera * InputMngr::GetCamera () const
	{
		return camera;
	}
}
