#pragma once

#include "SDL/SDL-1.2.14 sdk/include/SDL.h" // main SDL header

namespace Gfx {class Camera;}
namespace Gfx {class Viewport;}
namespace Input {class Keys;}
namespace Input {class Mouse;}

namespace Input
{
	class InputMngr
	{
	public:

		InputMngr (Int2 size);
		~InputMngr ();

		void Update ();

		Keys * GetKeys ();
		Mouse * GetMouse ();
		Gfx::Viewport * GetViewport ();
		const Gfx::Viewport * GetViewport () const;
		Gfx::Camera * GetCamera () const;

	private:

		Keys * keys;
		Mouse * mouse;
		Gfx::Viewport * viewport;
		Gfx::Camera * camera;
	};
}
