#pragma once

#include "SDL/SDL-1.2.14 sdk/include/SDL.h" // main SDL header

#include "Input_SingleInput.h"

namespace Input
{
	class Keys
	{
	public:

		Keys ();
		~Keys ();

		static bool isRegularInputKey (SDLKey key);

		bool IsDown (SDLKey sym) const;
		bool IsPressed (SDLKey sym) const;
		bool IsPressedOrRepeated (SDLKey sym) const;
		bool IsRelease (SDLKey sym) const;

		Uint16 ConsumeTextEntry ();

		void Update ();
		void RecordKeyPressed (SDLKey sym, SDLMod mod, Uint16 unicode);
		void RecordKeyReleased (SDLKey sym, SDLMod mod, Uint16 unicode);

	private:

		int stateLength;
		char * down;
		char * pressed;
		char * released;
		int * timeDown;

		static const int keysLength = 256;
		Uint16 keys [2][keysLength];
		int keysRecorded [2];
		int keysConsumed [2];
		int keysRecordBufferIdx;
	};
}