#pragma once

#include "Input_SingleInput.h"

namespace Input {class InputMngr;}

namespace Input
{
	class Mouse
	{
	public:

		Mouse ();

		void SetInputFocus (bool isAppFocused);
		void SetIsFpsMouse (bool useFpsMouse);
		bool GetIsFpsMouse () const;
		void ReportMouseButton (int idx, bool isDown);
		void ReportWheel (bool isUpClick);

		bool GetIsAbsoluteValid () const;
		Int2 GetAbsolute () const; // relative to the window of course! can return values outside the window, use GetIsInWindow () to check
		Int2 GetDelta () const;

		SingleInput Left;
		SingleInput Middle;
		SingleInput Right;
		int WheelDelta;

	private:

		friend class InputMngr;

		void Update ();
		
		void ChangeMouse ();

		bool isAbsPositionValid;
		
		Int2 pos;
		Int2 delta;

		bool ignoreNextInput;
		bool isAppFocused;
		bool isFpsMouse;
		int nextWheelDelta;
	};
}
