#include "stdafx.h"

#include "Input_SingleInput.h"

namespace Input
{
	SingleInput::SingleInput ()
		: isOn (false), 
		lastIsOn (false),
		wasOn (false),
		toggleTime (0.0f)
	{
	}

	bool SingleInput::IsOn () const
	{
		return isOn;
	}

	bool SingleInput::IsJustOn () const
	{
		return wasOn;
	}

	float SingleInput::TimeSinceToggle (float timeNow) const
	{
		return timeNow - toggleTime;
	}

	void SingleInput::SetIsOn (bool isOn, float timeNow, char debug)
	{
		if (this->isOn != isOn)
		{
			this->isOn = isOn;
			toggleTime = timeNow;
		}
		else if (debug != 0)
		{
			if (isOn)
			{
				Debug_WriteLine (0, "SingleInput - %c PRESSED", debug);
			}
			else
			{
				Debug_WriteLine (0, "SingleInput - %c RELEASED", debug);
			}
		}
	}

	void SingleInput::Update ()
	{
		wasOn = (isOn && !lastIsOn);
		lastIsOn = isOn;
	}
}