#pragma once

namespace SceneSim {class Column;}

namespace SceneCollections
{
	class LocalColumns
	{
	public:

		LocalColumns (Int3 centreColumnId, int radius);
		LocalColumns (const LocalColumns & copy);
		~LocalColumns ();

		void DeleteAll ();

		void AddColumn (SceneSim::Column * column);

		const SceneSim::Column * GetColumn (Int3 columnId) const;
		SceneSim::Column * GetColumn (Int3 columnId);

		int GetMaxColumnsCount () const;
		SceneSim::Column * GetNthColumn (int idx);

	private:

		int CalcArrayIndex (Int3 columnId) const;

		Int3 topLeftColumnId;
		int dims;

		SceneSim::Column * * columns;
	};
}
