#pragma once

#include <vector>

namespace SceneCollections
{
	template <typename T>
	bool Contains (const std::vector <T> * coll, const T & t);

	template <typename T>
	void Remove (std::vector <T> * coll, const T & t);
}




namespace SceneCollections
{
	template <typename T>
	bool Contains (const std::vector <T> * coll, const T & t)
	{
		assert (coll != NULL);

		for (std::vector <T>::const_iterator it = coll->begin (); it != coll->end (); ++it)
		{
			if (*it == t)
			{
				return true;
			}
		}
		return false;
	}

	template <typename T>
	void Remove (std::vector <T> * coll, const T & t)
	{
		assert (coll != NULL);

		for (std::vector <T>::iterator it = coll->begin (); ; ++it)
		{
			assert (it != coll->end ());

			if (*it == t)
			{
				coll->erase (it);
				break;
			}
		}
	}
}
