#pragma once

#include "Area_AreaDefs.h"

namespace File {class PakFileCompressed;}
namespace SceneSim {class Column;}

namespace SceneFile
{
	namespace Area
	{
		class AreaInstance
		{
		public:

			AreaInstance (TextRef fileFolder, AreaId areaId);
			~AreaInstance ();

			AreaId GetId () const;

			bool IsColumnLoadable (Int3 columnId) const;

			void LoadColumn_BaseData (SceneSim::Column * column);

			void SaveColumn (SceneSim::Column * column);

		private:

			static Text FileLeafFromAreaId (AreaId areaId);

			void LoadFileHeader ();
			void SaveFileHeader ();

			int RecordIdxFromColumnId (Int3 columnId) const;

			const AreaId areaId;

			File::PakFileCompressed * pakFile;
		};
	}
}
