#include "stdafx.h"

#include "../SceneSim/SceneSim_Column.h"

#include "Area_AreaInstance.h"
#include "Area_AreaMngr.h"

namespace SceneFile {namespace Area {class AreaInstance;}}

namespace SceneFile
{
	namespace Area
	{
		void DeleteAreaInstance (void * data)
		{
			AreaInstance * * instance = (AreaInstance * *) data;
			delete *instance;
		}

		AreaMngr::AreaMngr (TextRef fileFolder)
			: fileFolder (fileFolder),
			instance (NULL)
		{
		}

		AreaMngr::~AreaMngr ()
		{
			delete instance;
			instance = NULL;
		}

		bool AreaMngr::IsColumnLoadable (Int3 columnId)
		{
			AreaInstance * instance = GetOrCreate (columnId);
			return instance->IsColumnLoadable (columnId);
		}

		void AreaMngr::LoadColumn_BaseData (SceneSim::Column * column)
		{
			assert (column != NULL);

			AreaInstance * instance = GetOrCreate (column->columnId);
			return instance->LoadColumn_BaseData (column);
		}

		void AreaMngr::SaveColumn (SceneSim::Column * column)
		{
			assert (column != NULL);

			AreaInstance * instance = GetOrCreate (column->columnId);
			return instance->SaveColumn (column);
		}

		AreaInstance * AreaMngr::GetOrCreate (Int3 columnId)
		{
			AreaId areaId = AreaIdFromColumnId (columnId);

			if (instance == NULL)
			{
				instance = aah_new AreaInstance (fileFolder, areaId);
			}

			return instance;
		}
	}
}
