#include "stdafx.h"

#include "../SceneCollections/SceneCollections_ColumnIdVector.h"
#include "../SceneCollections/SceneCollections_Utils.h"
#include "../SceneHelper/SceneHelper_SimEvents.h"
#include "../SceneSim/SceneSim_Column.h"
#include "../SceneSim/SceneSim_ColumnCells.h"
#include "../SceneSim/SceneSim_Room.h"

#include "Factory_ColumnLoadJob.h"
#include "SceneFile_OperationsRoom.h"

namespace SceneFile
{
	namespace Factory
	{
		ColumnLoadJob::ColumnLoadJob 
		(
			Thread::JobMngr * jobMngr, 
			SceneSim::Room * room,
			Int3 columnId,
			OperationsRoom * roomOps,
			SceneHelper::SimEvents * events, 
			bool isEditing
		)
			: Thread::Job (jobMngr, true),
			room (room),
			column (NULL),
			roomOps (roomOps),
			events (events),
			isEditing (isEditing)
		{
			assert (room != NULL);
			assert (jobMngr != NULL);
			assert (roomOps != NULL);
			assert (events != NULL);

			column = aah_new SceneSim::Column (columnId);
		}

		ColumnLoadJob::~ColumnLoadJob ()
		{
		}

		Thread::JOBSTATES ColumnLoadJob::JobDoWork ()
		{
			//Text luaFilename (world->gameFolder + "data/world.lua");
			//if (Utils::File_Exists (luaFilename))
			//{
			//	world->lua = aah_new Lua::LuaState (luaFilename);
			//	Text version = world->lua->ReadString ("world/version");
			//	if (version == "dm_world_loader_00")
			//	{
			//		*ops = aah_new Gen00::Gen00_World (world);
			//	}
			//	else
			//	{
			//		assert (false);
			//	}
			//}
			//else
			//{
			//	// if there isn't one - then create the latest version
			//	SceneFile::CreateResults createResults = roomOps->CreateColumn (column);
			//	assert (createResults == SceneFile::CR_SUCCESS);
			//}

			SceneFile::LoadResults loadResults = roomOps->NewAsyncLoadColumn (column, isEditing);
			assert (loadResults == SceneFile::LR_SUCCESS);

			return Thread::JS_WORKDONE;
		}

		Thread::JOBSTATES ColumnLoadJob::JobOnCompleted ()
		{
			Job::JobOnCompleted ();

			roomOps->NewOnColumnLoadCompleted (room, column);
			
			events->OnColumnAdded (column);

			column = NULL;
			room = NULL;

			return Thread::JS_COMPLETED;
		}
	}
}