#pragma once

#include "Thread/Thread_Job.h"

namespace SceneHelper {class SimEvents;}
namespace SceneFile {class OperationsRoom;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	namespace Factory
	{
		class ColumnLoadJob : public Thread::Job
		{
		public:

			ColumnLoadJob (
				Thread::JobMngr * jobMngr, 
				SceneSim::Room * room,
				Int3 columnId,
				OperationsRoom * roomOps,
				SceneHelper::SimEvents * events,
				bool isEditing);

			virtual ~ColumnLoadJob ();

			virtual Thread::JOBSTATES JobDoWork ();
			virtual Thread::JOBSTATES JobOnCompleted ();

		private:

			// inputs
			SceneSim::Room * room;
			OperationsRoom * const roomOps;
			SceneHelper::SimEvents * events;
			bool isEditing;

			// working data
			SceneSim::Column * column;
		};
	}
}
