#include "stdafx.h"

#include "../SceneCollections/SceneCollections_ColumnIdVector.h"
#include "../SceneCollections/SceneCollections_Utils.h"
#include "../SceneHelper/SceneHelper_SimEvents.h"
#include "../SceneSim/SceneSim_Column.h"
#include "../SceneSim/SceneSim_ColumnCells.h"
#include "../SceneSim/SceneSim_Room.h"

#include "Factory_ColumnUnloadJob.h"
#include "SceneFile_OperationsRoom.h"

namespace SceneFile
{
	namespace Factory
	{
		ColumnUnloadJob::ColumnUnloadJob 
		(
			Thread::JobMngr * jobMngr, 
			SceneSim::Column * column,
			OperationsRoom * roomOps,
			SceneHelper::SimEvents * events
		)
			: Thread::Job (jobMngr, true),
			column (column),
			roomOps (roomOps),
			events (events)
		{
			assert (jobMngr != NULL);
			assert (column != NULL);
			assert (roomOps != NULL);
			assert (events != NULL);
		}

		ColumnUnloadJob::~ColumnUnloadJob ()
		{
		}

		Thread::JOBSTATES ColumnUnloadJob::JobDoWork ()
		{
			SceneFile::LoadResults loadResults = roomOps->NewAsyncUnloadColumn (column);
			assert (loadResults == SceneFile::LR_SUCCESS);

			return Thread::JS_WORKDONE;
		}

		Thread::JOBSTATES ColumnUnloadJob::JobOnCompleted ()
		{
			Job::JobOnCompleted ();

			roomOps->NewOnColumnUnloadCompleted (column);

			events->OnColumnRemoved (column);

			return Thread::JS_COMPLETED;
		}
	}
}