#pragma once

#include "Thread/Thread_Job.h"

namespace SceneHelper {class SimEvents;}
namespace SceneFile {class OperationsRoom;}
namespace SceneSim {class Column;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	namespace Factory
	{
		class ColumnUnloadJob : public Thread::Job
		{
		public:

			ColumnUnloadJob (
				Thread::JobMngr * jobMngr, 
				SceneSim::Column * column,
				OperationsRoom * roomOps,
				SceneHelper::SimEvents * events);

			virtual ~ColumnUnloadJob ();

			virtual Thread::JOBSTATES JobDoWork ();
			virtual Thread::JOBSTATES JobOnCompleted ();

		private:

			// inputs
			SceneSim::Column * const column;
			OperationsRoom * const roomOps;
			SceneHelper::SimEvents * events;
		};
	}
}
