#pragma once

#include "Thread/Thread_Job.h"

namespace SceneFile {class OperationsRoom;}
namespace SceneHelper {class SimEvents;}
namespace SceneHelper {namespace Collections {class RoomList;}}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}
namespace SceneSim {class WorldInit;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	namespace Factory
	{
		class RoomLoadJob : public Thread::Job
		{
		public:

			RoomLoadJob (
				Thread::JobMngr * jobMngr, 
				SceneSim::WorldInit * worldInit,
				TextRef roomId,
				SceneHelper::Collections::RoomList * roomsLoading, 
				OperationsRoom * * roomOps, 
				SceneSim::World * world,
				SceneHelper::SimEvents * events);

			virtual ~RoomLoadJob ();

			virtual Thread::JOBSTATES JobDoWork ();
			virtual Thread::JOBSTATES JobOnCompleted ();

		private:

			SceneSim::WorldInit * worldInit;
			SceneSim::Room * room;

			Thread::JobMngr * jobMngr;
			SceneHelper::Collections::RoomList * roomsLoading;
			OperationsRoom * * roomOps;
			SceneSim::World * world;
			SceneHelper::SimEvents * events;
		};
	}
}
