#pragma once

#include "Thread/Thread_Job.h"

namespace SceneFile {class OperationsWorld;}
namespace SceneHelper {class SimEvents;}
namespace SceneSim {class World;}
namespace SceneSim {class WorldInit;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	namespace Factory
	{
		class WorldLoadJob : public Thread::Job
		{
		public:

			WorldLoadJob (Thread::JobMngr * jobMngr, SceneSim::WorldInit * worldInit, SceneSim::World * world, OperationsWorld * * ops, SceneHelper::SimEvents * events);
			virtual ~WorldLoadJob ();

			virtual Thread::JOBSTATES JobDoWork ();
			virtual Thread::JOBSTATES JobOnCompleted ();

		private:

			SceneSim::World * world;
			SceneSim::WorldInit * worldInit;
			OperationsWorld * * ops;
			SceneHelper::SimEvents * events;

			Thread::JobMngr * jobMngrForChildren;
		};
	}
}
