#include "stdafx.h"

#include "../CellBuilder/CellBuilder_Mngr.h"
#include "../CellBuilder/CellBuilder_ShapeBase.h"
#include "../SceneSim/SceneSim_Column.h"
#include "../SceneSim/SceneSim_ColumnCells.h"

#include "SceneFile_Lighting.h"

namespace SceneFile
{
	namespace Lighting
	{
		void CalcStripSky (SceneSim::Column * column, Int2 stripId, const CellBuilder::Mngr * cellBuilder)
		{
			SceneSim::ColumnCells * cells = column->GetCells ();

			const int height = column->GetSize ().y;

			int blockedBy = 0;
			for (int y = height - 1; y >= 0; --y)
			{
				SceneSim::Cell * cell = cells->GetCell (stripId.x, y, stripId.y);
				const CellBuilder::ShapeBase * shape = cellBuilder->GetShape (cell->type);

				int light = (blockedBy > 0) ? 11 : 15;
				if (shape->blocksLight)
				{
					++blockedBy;
				}
				cell->lightSky = (light > 5) ? light : 5;
				cell->lightSrc = 0;
			}

			// OLD V2

			//int blockedBy = 0;
			//for (int y = SceneSim::CellsPerColY - 1; y >= 0; --y)
			//{
			//	SceneSim::Cell * cell = cells->GetCell (stripId.x, y, stripId.y);
			//	const CellBuilder::ShapeBase * shape = cellBuilder->GetShape (cell->type);

			//	int light = 15 - (blockedBy + 2) / 3;
			//	if (shape->blocksLight)
			//	{
			//		++blockedBy;
			//	}
			//	cell->lightSky = (light > 5) ? light : 5;
			//	cell->lightSrc = 0;
			//}



			// OLD V1

			//assert (column != NULL);
			//assert (cellBuilder != NULL);

			//Column * adjs [3][3];
			//ColumnCells * adjCells [3][3];

			//adjs [F_T] = NULL;
			//adjs [F_B] = NULL;
			//adjCells [F_T] = NULL;
			//adjCells [F_B] = NULL;

			//for (int idx = F_COUNT_ALL; idx < F_COUNT_ALL; ++idx)
			//{
			//	adjs [idx] = column->GetAdjacentColumn ((FACES) idx);
			//	assert (adjs [idx] != NULL);
			//	adjCells [idx] = adjs [idx]->GetCells ();
			//}

			//ColumnCells * cells = column->GetCells ();
			//int threshold = cells->GetSkyLightLevel (stripId);

			//// fully lit
			//int y = CellsPerColY - 1;
			//for (; y > threshold; --y)
			//{
			//	Cell * cell = cells->GetCell (stripId.x, y, stripId.y);
			//	cell->lightSky = 15;
			//	cell->lightSrc = 0;
			//}

			//// check around for neighbours threshold
			//int threshold = 0;
			//for (int radius = 1; radius < 3; ++idx)
			//{
			//	for (int xx = stripId.x - radius; xx <= stripId.x + radius; ++xx)
			//	{
			//		for (int zz = stripId.y - radius; zz <= stripId.y + radius; ++zz)
			//		{
			//			
			//		}
			//	}
			//}

			//// continue downwards now - getting darker
			//for (; y >= 0; --y)
			//{
			//	Cell * cell = cells->GetCell (stripId.x, y, stripId.y);
			//	cell->lightSky = 8;
			//	cell->lightSrc = 0;
			//}
		}

		void CalcStripSky (SceneSim::Column * column, Int3 cellId, const CellBuilder::Mngr * cellBuilder)
		{
			CalcStripSky (column, Int2 (cellId.x, cellId.z), cellBuilder);
		}
	}
}


