#include "stdafx.h"

#include "../SceneCollections/SceneCollections_Utils.h"
#include "../SceneSim/SceneSim_Column.h"
#include "../SceneSim/SceneSim_Room.h"
#include "../SceneSim/SceneSim_World.h"

#include "Area_AreaMngr.h"
#include "Factory_ColumnLoadJob.h"
#include "SceneFile_OperationsRoom.h"

namespace SceneFile
{
	OperationsRoom::OperationsRoom (SceneSim::Room * room, Thread::JobMngr * jobMngr, SceneSim::World * world, SceneHelper::SimEvents * events)
		: room (room),
		jobMngr (jobMngr),
		world (world),
		events (events)
	{
		assert (room != NULL);
		assert (jobMngr != NULL);
		assert (world != NULL);
		assert (events != NULL);

		Text filePath = world->GetGameFolder () + "data/rooms/" + room->roomId + "/";
		areaMngr = aah_new Area::AreaMngr (filePath);
		//areaMngr = aah_new Area::AreaMngr ("C:/git/micro_adventures/output/worlds/client_savetest/data/rooms/default/");
	}

	OperationsRoom::~OperationsRoom ()
	{
		delete areaMngr;
	}
}
