#pragma once

#include "../SceneCollections/SceneCollections_ColumnIdVector.h"

#include "SceneFile_OperationsDefs.h"

namespace Area {class AreaMngr;}
namespace SceneHelper {class SimEvents;}
namespace SceneHelper {namespace Collections {class ColumnList;}}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}
namespace SceneSim {class WorldInit;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	class OperationsRoom
	{
	public:

		OperationsRoom (SceneSim::Room * room, Thread::JobMngr * jobMngr, SceneSim::World * world, SceneHelper::SimEvents * events);
		virtual ~OperationsRoom ();

		virtual void NewColumnLoad (Int3 columnId, bool isEditing) = 0;
		virtual void NewColumnUnload (SceneSim::Column * column) = 0;
		virtual void NewOnColumnLoadCompleted (SceneSim::Room * room, SceneSim::Column * column) = 0;
		virtual void NewOnColumnUnloadCompleted (SceneSim::Column * column) {assert (false);}
		virtual bool NewIsColumnRequested (const SceneSim::Room * room, Int3 columnId) const = 0;
		virtual LoadResults NewAsyncLoadColumn (SceneSim::Column * column, bool isEditing) = 0;
		virtual LoadResults NewAsyncUnloadColumn (SceneSim::Column * column) {assert (false); return LR_FAIL;}

		// are the following used any more? ! remove !

		virtual CreateResults CreateRoom (SceneSim::WorldInit * worldInit) = 0;
		virtual LoadResults LoadRoom () = 0;
		virtual SaveResults SaveRoom (void) {assert (false); return SR_FAIL;}

		//virtual CreateResults CreateColumn (SceneSim::Column * column) = 0;
		//virtual LoadResults AsyncLoadColumn (SceneSim::Column * column) = 0;
		//virtual SaveResults SaveColumn (void) {assert (false); return SR_FAIL;}

		//virtual void UnloadColumn (SceneSim::Column * column) = 0;

	protected:

		SceneSim::Room * room;
		Thread::JobMngr * jobMngr;
		SceneSim::World * world;
		SceneHelper::SimEvents * events;

		SceneCollections::ColumnIdVector columnsLoading;
		SceneCollections::ColumnIdVector columnsUnloading;

		Area::AreaMngr * areaMngr;

		//SceneCollections::ColumnVector columnsLoadedButNotStitched;
	};
}