#include "stdafx.h"

#include "../SceneHelper/SceneHelper_Collections.h"

#include "Factory_RoomLoadJob.h"
#include "SceneFile_OperationsRoom.h"
#include "SceneFile_OperationsWorld.h"

namespace SceneFile
{
	OperationsWorld::OperationsWorld (Thread::JobMngr * jobMngr, SceneSim::WorldInit * worldInit, SceneSim::World * world, SceneHelper::SimEvents * events)
		: jobMngr (jobMngr),
		worldInit (worldInit),
		world (world),
		events (events),
		roomOps (NULL)
	{
		assert (jobMngr != NULL);
		assert (worldInit != NULL);
		assert (world != NULL);
		assert (events != NULL);
		
		roomsLoading = aah_new SceneHelper::Collections::RoomList ();
	}

	OperationsWorld::~OperationsWorld ()
	{
		roomsLoading->DeleteAll ();

		delete roomsLoading;

		delete roomOps;
	}

	void OperationsWorld::NewRoomLoad (TextRef roomId)
	{
		if (roomsLoading->FindById (roomId) == NULL)
		{
			// rooms are always added to queue
			Factory::RoomLoadJob * job = aah_new Factory::RoomLoadJob (jobMngr, worldInit, roomId, roomsLoading, &roomOps, world, events);
			job->AddToQueue (Thread::JB_NORMAL);
		}
	}

	OperationsRoom * OperationsWorld::GetRoomOps (TextRef roomId)
	{
		return roomOps;
	}
}
