#pragma once

#include "SceneFile_OperationsDefs.h"

namespace SceneFile {class OperationsRoom;}
namespace SceneHelper {class SimEvents;}
namespace SceneHelper {namespace Collections {class RoomList;}}
namespace SceneSim {class World;}
namespace SceneSim {class WorldInit;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	class OperationsWorld
	{
	public:

		OperationsWorld (Thread::JobMngr * jobMngr, SceneSim::WorldInit * worldInit, SceneSim::World * world, SceneHelper::SimEvents * events);
		virtual ~OperationsWorld ();

		void NewRoomLoad (TextRef roomId);
		OperationsRoom * GetRoomOps (TextRef roomId);

		virtual CreateResults CreateWorld () = 0;
		virtual LoadResults LoadWorld () = 0;
		virtual SaveResults SaveWorld (void) {assert (false); return SR_FAIL;}

	protected:

		Thread::JobMngr * jobMngr;
		SceneSim::WorldInit * worldInit;
		SceneSim::World * world;
		SceneHelper::SimEvents * events;

		SceneHelper::Collections::RoomList * roomsLoading;

		OperationsRoom * roomOps;
	};
}