#pragma once

namespace Lua {class LuaState;}
namespace SceneFile {class OperationsWorld;}
namespace SceneHelper {class SimEvents;}
//namespace SceneHelper {class SimMngr;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}
namespace SceneSim {class WorldInit;}
namespace Thread {class JobMngr;}

namespace SceneFile
{
	class SimFactory
	{
	public:

		SimFactory (SceneSim::WorldInit * worldInit, SceneSim::World * world, SceneHelper::SimEvents * events, bool isEditing);
		~SimFactory ();

		int GetJobCount ();
		void Update ();

		void AbortAsyncAndSave ();

		void RequestWorldLoad ();
		void RequestRoomLoad (TextRef roomId);
		void RequestColumnLoad (SceneSim::Room * room, Int3 columnId);

		bool IsColumnRequested (const SceneSim::Room * room, Int3 columnId) const;

		void RequestWorldUnload ();
		void RequestRoomUnload (TextRef roomId);
		void RequestColumnUnload (SceneSim::Column * column);

	private:

		SceneSim::WorldInit * worldInit;
		SceneSim::World * world;
		SceneHelper::SimEvents * events;
		bool isEditing;

		Thread::JobMngr * jobMngr;
		OperationsWorld * worldOps;
	};
}
