#include "stdafx.h"

#include "Lua/Lua_LuaState.h"

#include "../SceneHelper/SceneHelper_SimMngr.h"
#include "../SceneSim/SceneSim_World.h"
#include "../SceneSim/SceneSim_WorldInit.h"

#include "Ld00_World.h"

namespace SceneGen
{
	namespace Ld_00
	{
		Ld_00_World::Ld_00_World (Thread::JobMngr * jobMngr, SceneSim::WorldInit * init, SceneSim::World * world, SceneHelper::SimEvents * events)
			: OperationsWorld (jobMngr, init, world, events)
		{
			assert (world != NULL);
			assert (world->loadState == SceneSim::LS_LOADING);
		}

		Ld_00_World::~Ld_00_World ()
		{
		}

		SceneFile::CreateResults Ld_00_World::CreateWorld ()
		{
			//Debug_WriteLine (0, "World created: %s", world->GetGameFolder ().Raw ());

			// copy all files required for the world

			bool isOk = Utils::File_CopyFolder (world->GetGameFolder (), "data_default/new_world_00/", false);
			assert (isOk);

			// update the world lua

			world->lua = aah_new Lua::LuaState (world->GetGameFolder () + "data/world.lua");
			world->lua->SetString ("world/title", worldInit->name);
			world->lua->SaveText_GlobalTable (world->GetGameFolder () + "data/world.lua", "world", Lua::LuaState::WL_NONE);

			return (isOk) ? SceneFile::CR_SUCCESS : SceneFile::CR_FAIL;
		}

		SceneFile::LoadResults Ld_00_World::LoadWorld ()
		{
			assert (world->loadState == SceneSim::LS_LOADING);

			//Debug_WriteLine (0, "World loaded: %s", world->GetGameFolder ().Raw ());

			world->lua = aah_new Lua::LuaState (world->GetGameFolder () + "data/world.lua");

			return SceneFile::LR_SUCCESS;
		}
	}
}