#pragma once

#include <list>

namespace SceneSim {class Column;}
namespace SceneSim {class Room;}

namespace SceneHelper
{
	namespace Collections
	{
		class ColumnList : private std::list <SceneSim::Column *>
		{
		public:

			~ColumnList ();

			void Add (SceneSim::Column * room);
			int Size () const;
			SceneSim::Column * FindById (Int3 columnId);
			void Erase (SceneSim::Column * room);
			void DeleteAll ();
		};

		class RoomList : private std::list <SceneSim::Room *>
		{
		public:

			~RoomList ();

			void Add (SceneSim::Room * room);
			int Size () const;
			SceneSim::Room * FindById (TextRef roomId);
			SceneSim::Room * GetNth (int nth);
			void Erase (SceneSim::Room * room);
			void DeleteAll ();
		};
	}
}
