#pragma once

namespace SceneSim {class CellChangeData;}
namespace SceneSim {class Column;}
namespace SceneSim {class Room;}
namespace SceneSim {class World;}

namespace SceneHelper
{
	class SimEvents
	{
	public:

		virtual void OnWorldAdded (SceneSim::World * world) = 0;
		virtual void OnWorldRemoved (SceneSim::World * world) = 0;

		virtual void OnRoomAdded (SceneSim::Room * room) = 0;
		virtual void OnRoomRemoved (SceneSim::Room * room) = 0;

		virtual void OnColumnAdded (SceneSim::Column * column) = 0;
		virtual void OnColumnRemoved (SceneSim::Column * column) = 0;

		virtual void OnTerrainCsgApplied (SceneSim::Column * column, Int3 cellId, float radius, int cellType) = 0;
	};
}
