#pragma once

#include "SceneSim_Cell.h"

namespace SceneSim
{
	class ColumnCells
	{
	public:

		ColumnCells (int cellsPerColY);
		ColumnCells (const ColumnCells & copyFrom);
		~ColumnCells ();

		const Cell * GetCell (int colRelX, int  colRelY, int colRelZ) const;
		const Cell * GetCell (Int3 colRelPos) const;
		Cell * GetCell (int colRelX, int colRelY, int colRelZ);
		Cell * GetCell (Int3 colRelPos);

		void CopyFrom (const ColumnCells * copyFrom);
		void * GetRawDataToSave (int * length);

		//unsigned char GetSkyLightLevel (Int2 stripId);
		//void SetSkyLightLevel (Int2 stripId, unsigned char level);

		static const SceneSim::Cell dummyAirCell;

	private:

		// NOTE: all direct access to "cells" array must be Y X Y, not X Y Z
		Cell * rawData;

		const int cellsPerColY;
	};
}
