#pragma once

//#define REPLACE_UNKNOWN_CELLS_WITH_AIR

namespace SceneSim {class Column;}

namespace SceneSim
{
	enum FACES
	{
		F_T,
		F_B,
		F_N,
		F_E,
		F_S,
		F_W,
		F_OTHER,

		F_COUNT_ALL,
		F_COUNT_CUBE = 6,
		F_NONE,
	};

	enum FACEFLAGS
	{
		FF_T		= 1 << F_T,
		FF_B		= 1 << F_B,
		FF_N		= 1 << F_N,
		FF_E		= 1 << F_E,
		FF_S		= 1 << F_S,
		FF_W		= 1 << F_W,
		FF_OTHER	= 1 << F_OTHER,
	};

	enum ENTCOLLISIONS
	{
		EC_NONE,
		EC_UNITCUBE,
		EC_HALFSTEP,
		EC_STAIR,
		EC_FENCEPOST,
	};

	enum LOADSTATES
	{
		LS_NONE,
		LS_LOADREQUESTED,
		LS_LOADING,
		LS_JUSTLOADED,
		LS_LOADCOMPLETE,
	};

	enum UNLOADSTATES
	{
		US_NONE,
		US_UNLOADREQUESTED,
		US_UNLOADING,
		US_JUSTUNLOADED,
		US_UNLOADCOMPLETE,
	};

	struct RoomPos
	{
		Int3 column;
		Int3 cell;
	};

	typedef unsigned short CellType;

	static const int FixedSize = 16; // ludum dare - remove infinite level and have 16 x 16
	static const int CellsPerColXz = 8;
	static const int CellsPerColY = 128; // no higher than 256 - sometimes we have to store this in unsigned char (to be fixed)

	extern FACES GetOppositeFace (FACES face);
	extern Int3 GetDeltaFromFace (FACES face);
	extern void FixCell (Int3 * columnId, Int3 * cellId);

	struct AdjColumns
	{
		AdjColumns ();
		AdjColumns (Column * main, Column * n, Column * e, Column * s, Column * w);

		bool operator == (const AdjColumns & other) const;

		void DeleteAll ();

		Column * main;
		Column * n;
		Column * e;
		Column * s;
		Column * w;
	};
}
