#pragma once

#include "SceneSim_Defs.h"

#include <list>

namespace CellBuilder {class Mngr;}
namespace Ents {class Player;}
namespace Ents {namespace Comps {class Coord;}}
namespace Lua {class LuaState;}
namespace SceneSim {class Column;}
namespace SceneSim {class ColumnCollection;}
namespace SceneSim {class World;}
namespace Input {class InputMngr;}

namespace SceneSim
{
	class Room
	{
	public:

		

		Room (Text roomId);
		~Room ();

		void LoadLua (TextRef filename);
		void OnAddedToWorld (World * world);
		void OnRemovedFromWorld ();

		World * GetWorld (); // this is definitive test of whether it is ready or not
		Lua::LuaState * GetLua ();
		const CellBuilder::Mngr * GetCellBuilder () const;
		int GetRandomSeed () const;
		int GetNewColumnHeight () const;

		void Update (Input::InputMngr * mngr, Ents::Player * player);

		void AddColumn (Column * column);
		void RemoveColumn (Column * column);

		Column * GetColumn (Int3 columnId) const;
		Column * GetNthLoadedColumn (int nth) const;

		const Text roomId;

	private:

		World * world;
		Lua::LuaState * lua;
		int randomSeed;
		int newColumnHeight;

		Column * columns [FixedSize][FixedSize];
		int columnsLoadedCount;

		CellBuilder::Mngr * cellBuilder;
	};
}
