#pragma once

#include "SceneSim_Defs.h"

#include <map>

namespace Input {class InputMngr;}
namespace Lua {class LuaState;}
namespace SceneHelper {namespace Collections {class RoomList;}}
namespace SceneHelper {namespace Factory {class WorldLoadJob;}}
namespace SceneHelper {class SimFactory;}
namespace SceneSim {class Room;}
namespace SceneSim {class WorldInit;}

namespace SceneSim
{
	class World
	{
	public:

		World ();
		//World (TextRef gameFolder);
		~World ();

		void AsyncInit (WorldInit * init);
		void OnLoadCompleted ();

		TextRef GetGameFolder () const;

		void AddRoom (Room * room);
		void RemoveRoom (Room * room);

		bool IsRoomLoaded (Text roomId) const;
		Room * GetRoom (Text roomId);
		Room * GetRoomNth (int nth);

		Lua::LuaState * lua;
		LOADSTATES loadState;

	private:

		friend class SceneHelper::SimFactory;
		friend class SceneHelper::Factory::WorldLoadJob;

		Text gameFolder;

		//SceneHelper::SimMngr * const mngr;

		SceneHelper::Collections::RoomList * roomsLoaded;
	};
}
