#pragma once

#include "File_PakFileBase.h"

namespace File
{
	class PakFileCompressed : protected PakFileBase
	{
	public:

		PakFileCompressed (TextRef filename, int recordCount);
		virtual ~PakFileCompressed ();

		bool DoesRecordExist (int recordIdx) const;

		int LoadRecord (int recordIdx, RakNet::Time * lastModified, void * out, int maxOut);

		void SaveRecord (int recordIdx, const RakNet::Time * lastModified, void * in, int size, int compressionLevel);

	private:

		unsigned char * compressionBuffer;
		const int compressionBufferSize;
		

		//unsigned int Debug_GetChecksum (int recordIdx, unsigned char * data, int length) const;

	//private:

		//static const int blockSize = 1024 * 4; // any benefit to matching cluster size?

		//void InitNewHeader (int recordCount);
		//void SaveHeader (bool addPadding);

		//int GetMinBlockCount (int size) const;
		//void PadToNextBlock (std::fstream * file);
		//int FindFirstFreeBlocks (int blockCount) const;
		//
		//static unsigned char padBuffer [blockSize];

		//Text filename;

		//PakFileHeader header;
		//PakFileRecord * records;

		//int * sortedRecordIds;
	};
}
