#pragma once

typedef struct lua_State lua_State;

namespace Lua
{
	class LuaState
	{
	public:

		enum WARNINGLEVELS
		{
			WL_NONE,
			WL_SAVEDONCEONLY,
			WL_SAVEDREPEATEDLY,
		};

		LuaState (TextRef filename);
		~LuaState ();

		void Save ();
		void SaveAs (TextRef filename);

		int ReadInt (TextRef path) const;
		bool ReadBool (TextRef path) const;
		float ReadFloat (TextRef path) const;
		const char * ReadString (const Text & path) const;
		Int3 ReadInt3 (TextRef path) const;
		Vec3 ReadVec3 (TextRef path) const;

		bool SetInt (TextRef path, int value);
		bool SetBool (TextRef path, bool value);
		bool SetFloat (TextRef path, float value);
		bool SetString (TextRef path, TextRef value);
		bool SetInt3 (TextRef path, Int3 value);
		bool SetVec3 (TextRef path, Vec3 value);

		bool SaveText_GlobalTable (TextRef filename, TextRef globalTable, WARNINGLEVELS warningLevel);

	private:

		bool LoadPath (TextRef path, bool getFinalValue) const;

		Text filename;

		mutable lua_State * state;

		mutable char buffer [512];
	};
}
