#pragma once

#include "Mem_Sentinels.h"

struct SDL_mutex;
namespace Mem {class Record;}

namespace Mem
{
	class Context
	{
	public:

		Context (TextRef title, bool isThreadSafe);
		~Context ();

		void AddRecord (SentinelPre * sentinel);
		void RemoveRecord (SentinelPre * sentinel);

		void AssertOnAlloc (void * adr);

	private:

		Text title;
		mutable SDL_mutex * lock;

		int allocCount;
		size_t allocSize;

		static const int recordsMax = 1000;
		Record * records;

		static const int trackingMax = 10;
		int trackingCurrent;
		void * tracking [trackingMax];
	};
}