#include "stdafx.h"

#include "Profile_ProfileApp.h"
#include "Profile_ProfileThread.h"



namespace Profile
{

#if defined (PROFILER_ENABLE)

	struct ProfileAppGlobals
	{
		ProfileAppGlobals ()
		{
			threadsCount = 0;
			memset (threads, 0, sizeof (threads));
			memset (threadIds, 0, sizeof (threadIds));
		}

		static const int threadsMax = 20;

		int threadsCount;
		ProfileThread * threads [threadsMax];
		DWORD threadIds [threadsMax];
	};

	ProfileAppGlobals g_profileApp;

#endif

	void ProfileApp::Init ()
	{
	}

	void ProfileApp::Exit ()
	{

#if defined (PROFILER_ENABLE)

		for (int idx = 0; idx < g_profileApp.threadsCount; ++idx)
		{
			delete g_profileApp.threads [idx];
			g_profileApp.threads [idx] = NULL;
		}

#endif 

	}

	void ProfileApp::Update ()
	{

#if defined (PROFILER_ENABLE)

		for (int idx = 0; idx < g_profileApp.threadsCount; ++idx)
		{
			g_profileApp.threads [idx]->Update ();
		}

#endif

	}

	void ProfileApp::RegisterThread (const char * name)
	{

#if defined (PROFILER_ENABLE)

		assert (FindThread () == NULL);
		int idx = g_profileApp.threadsCount++;
		g_profileApp.threadIds [idx] = GetCurrentThreadId ();
		g_profileApp.threads [idx] = aah_new ProfileThread (name);

#endif

	}

	ProfileThread * ProfileApp::FindThread ()
	{

#if defined (PROFILER_ENABLE)

		const DWORD threadId = GetCurrentThreadId ();
		for (int idx = 0; idx < g_profileApp.threadsCount; ++idx)
		{
			if (g_profileApp.threadIds [idx] == threadId)
			{
				return g_profileApp.threads [idx];
			}
		}

#endif 

		return NULL;
	}

	ProfileThread * ProfileApp::GetThreadByIdx (int idx)
	{

#if defined (PROFILER_ENABLE)

		if (idx >= g_profileApp.threadsCount)
		{
			return NULL;
		}
		return g_profileApp.threads [idx];

#else

		return NULL;

#endif

	}

	void ProfileApp::ReportToScreen (const char * title)
	{

#if defined (PROFILER_ENABLE)

		printf ("####### PROFILER BEGIN -- %s\n", title);
		
		for (int idx = 0; idx < g_profileApp.threadsCount; ++idx)
		{
			g_profileApp.threads [idx]->ReportToScreen ();
		}

		printf ("\n");
		printf ("####### PROFILER END\n");


#endif

	}
}
