#pragma once

#include "Profile_ProfileApp.h"
#include "Profile_ProfileThread.h"

#if defined (PROFILER_ENABLE)

#	define PROFILE_RECORD_SCOPE(_name, _r, _g, _b) \
		static Profile::ProfileThread * profile_profiler = Profile::ProfileApp::FindThread (); \
		static int profile_recordId = profile_profiler->CreateRecordId (_name, _r, _g, _b); \
		Profile::ProfileScope profile_scope (profile_profiler, profile_recordId);

#else

#	define PROFILE_RECORD_SCOPE(_name, _r, _g, _b) while (false) {}

#endif

namespace Profile
{
	class ProfileScope
	{
	public:

		ProfileScope (ProfileThread * profiler, int recordId);
		~ProfileScope ();

	private:

		ProfileThread * profiler;
		const int recordId;
	};
}
