#include "stdafx.h"

#include "Thread_Job.h"
#include "Thread_JobMngr.h"

namespace Thread
{
	Job::Job (JobMngr * jobMngr, bool deleteSelfOnCompletion)
		: threadId (SDL_ThreadID ()),
		state (JS_NONE),
		jobMngr (jobMngr),
		deleteSelfOnCompletion (deleteSelfOnCompletion)
	{
		assert (jobMngr != NULL);
	}

	JOBSTATES Job::GetState () const
	{
		return state;
	}

	void Job::AddToQueue (JOBPRIORITIES priority)
	{
		jobMngr->AddJob (this, priority);
	}

	Job::~Job ()
	{
		assert (state != JS_WORKING); // dont delete while its in operation!
	}

	JOBSTATES Job::JobOnCompleted ()
	{
		assert (SDL_ThreadID () == threadId);
		return JS_NONE;
	}

	void Job::DeleteThis ()
	{
		jobMngr->DeleteJob (this);
	}
}
