#pragma once

namespace Thread {class JobMngr;}

namespace Thread
{
	enum JOBPRIORITIES
	{
		JB_HIGH,
		JB_NORMAL,

		JB_DEFAULT = JB_NORMAL,
	};

	enum JOBSTATES
	{
		JS_NONE,
		JS_QUEUED,
		JS_WORKING,
		JS_WORKDONE,
		JS_COMPLETED,
		JS_ERROR,
	};

	class Job
	{
	public:

		Job (JobMngr * jobMngr, bool deleteSelfOnCompletion = false);

		JOBSTATES GetState () const;

		void AddToQueue (JOBPRIORITIES priority);

	protected:

		friend class JobMngr;

		virtual ~Job ();

		virtual JOBSTATES JobDoWork () = 0;
		virtual JOBSTATES JobOnCompleted () = 0;

		void DeleteThis ();			

	private:

		const unsigned int threadId;

		JOBSTATES state;

		JobMngr * jobMngr;
		const bool deleteSelfOnCompletion;
	};
}
