#pragma once

#include <queue>

namespace Thread
{
	template <typename T>
	class SafeQueue : private std::queue <T>
	{
	public:

		SafeQueue ();
		~SafeQueue ();

		void Lock () const;
		void Unlock () const;
		int Size () const;

		void Push (T t);
		T Pop ();

	private:

		mutable SDL_mutex * lock;
	};
}

#include "Thread_SafeQueue.impl"

