#include "stdafx.h"

#include "../ExternalLibs/zlib/zlib.h"

namespace Utils
{
	int Zlib_Uncompress (void * input, int inputSize, void * output, int outputMax)
	{
		//ZEXTERN int ZEXPORT inflate OF((z_streamp strm, int flush));
		
		z_stream str;

	    str.zalloc = (alloc_func) Z_NULL;
	    str.zfree = (free_func) Z_NULL; 
		str.opaque = (voidpf) Z_NULL;

		str.next_in  = (unsigned char *) input;
		str.avail_in = inputSize;
		str.next_out = (unsigned char *) output;
		str.avail_out = outputMax;


		int err = inflateInit (&str);
		if (err != Z_OK)
		{
			//fprintf (Debug_GetLog (), "err = inflateInit\n");
			exit (0);
		}

		while (str.total_out < (unsigned) outputMax && str.total_in < (unsigned) inputSize)
		{
			err = inflate (&str, Z_FINISH);
			if (err != Z_STREAM_END)
			{
				//fprintf (Debug_GetLog (), "err = inflate\n");
				exit (0);
			}
			assert (err == Z_STREAM_END);
			if (err == Z_STREAM_END) 
			{
				break;
			}
			//fprintf (Debug_GetLog (), "Zlib_Uncompress failed in one pass\n");
			exit (0);

			assert (false);
			if (err < Z_OK)
			{
				int i = 0;
			}
		}

	    err = inflateEnd (&str);
		if (err != Z_OK)
		{
			//fprintf (Debug_GetLog (), "err = inflateEnd\n");
			exit (0);
		}

		return str.total_out;
	}

	int Zlib_Compress (void * input, int inputSize, void * output, int outputMax, int compressionLevel)
	{
		//ZEXTERN int ZEXPORT inflate OF((z_streamp strm, int flush));
		
		z_stream str;

	    str.zalloc = (alloc_func) Z_NULL;
	    str.zfree = (free_func) Z_NULL; 
		str.opaque = (voidpf) Z_NULL;

		str.next_in  = (unsigned char *) input;
		str.avail_in = inputSize;
		str.next_out = (unsigned char *) output;
		str.avail_out = outputMax;

		int err = deflateInit (&str, compressionLevel);

		//int err = deflateInit (&str, Z_DEFAULT_COMPRESSION);
		//int err = deflateInit (&str, 0);
		//int err = deflateInit (&str, 9);
		if (err != Z_OK)
		{
			//fprintf (Debug_GetLog (), "err = inflateInit\n");
			exit (0);
		}

		while (str.total_out < (unsigned) outputMax && str.total_in < (unsigned) inputSize)
		{
			err = deflate (&str, Z_FINISH);
			if (err != Z_STREAM_END)
			{
				//fprintf (Debug_GetLog (), "err = inflate\n");
				exit (0);
			}
			assert (err == Z_STREAM_END);
			if (err == Z_STREAM_END) 
			{
				break;
			}
			//fprintf (Debug_GetLog (), "Zlib_Uncompress failed in one pass\n");
			exit (0);

			assert (false);
			if (err < Z_OK)
			{
				int i = 0;
			}
		}

	    err = deflateEnd (&str);
		if (err != Z_OK)
		{
			//fprintf (Debug_GetLog (), "err = inflateEnd\n");
			exit (0);
		}

		return str.total_out;
	}
}

