#pragma once

//namespace Gfx {class Font;}

namespace Utils
{
	class DebugStream
	{
	public:
		virtual ~DebugStream ();

		virtual void WriteLine (const char * str) = 0;
		virtual void Flush ();

		virtual void Clear () {};
	};

	class DebugStream_Console : public DebugStream
	{
	public:
		virtual void WriteLine (const char * str);
	};

	extern void Debug_Init (int channel, DebugStream * debugStream);
	extern void Debug_Exit ();

	extern void Debug_WriteLine (int channel, const char * fmt, ...);
	extern void Debug_Flush (int channel);
	extern void Debug_Clear (int channel);
}
